C   14/04/87 909281412  MEMBER NAME  BPRFL    *.FORT        FORTRAN77
C******************** BPRFL ********************************************
      SUBROUTINE BPRFL(LBPRFL,NBPRFL,KBPRFL,MBPRFL,
     %   NT,MT,MT1,MT2,
     %   DT,DXYZ,RTZ,SIG,NX,NY,NP,NTS,
     %   XY,ZZ,XYTS,ZTS0,IQX,IQY)
C  PLOT INSTANTANEOUS BEAM PROFILE BY LINE PRINTER
      PARAMETER (LLIN=133,MPG=80)
      INCLUDE '@TDCOM'
      REAL*4 XYTS(0:MT,NTS,2),ZTS0(NTS),ZZ(NP,2),XY(NP,2,2),
     *       DXYZ(3),SIG(3)
      INTEGER*2 IQX(-NX:NX,MT/2,2),IQY(-NY:NY,MT/2,2)
      CHARACTER*133 PAGE(MPG)
      CHARACTER*120 TTL
      DIMENSION KMIN(2),KMAX(2),NXY(2),IXY0(2),NOUT2(2),IK0(2)
      CHARACTER*4 LXYZ(3)/'X/DX','Y/DY','Z/DZ'/
      CHARACTER*3 LWORK
      CHARACTER*1 MARK(10,2)/' ','1','2','3','4','5','6','7','8','9',
     *                       ' ','.',':','+','*','$','#','!','&','@'/
      INTEGER*2 IQM
      INTEGER MRGNT/6/,MRGNL/7/,MRGNB/4/
C
      IF(MOD(NT,MAX(1,NBPRFL)).NE.0.AND.NT.NE.MT1.AND.NT.NE.MT2)
     *         RETURN
      ZMX=MAX(ABS(ZZ(1,1)),ABS(ZZ(1,2)),ABS(ZZ(NP,1)),ABS(ZZ(NP,2)))
      IF(LBPRFL.NE.1.AND.LBPRFL.NE.3) GOTO 700
      MZ=MT/2
      IB0=MRGNT
      IXY0(1)=IB0+NX+1
      IB1=IXY0(1)+NX+1
      IXY0(2)=IB1+NY+1
      IB2=IXY0(2)+NY+1
      NLIN=IB2+MRGNB-1
      IF(NLIN.GT.MPG) GOTO 900
      NXY(1)=NX
      NXY(2)=NY
      IQM=0
      CALL CLEAR(IQX,(2*NX+1)*MZ)
      CALL CLEAR(IQY,(2*NY+1)*MZ)
      DO 260 L=1,2
      SGN=3-2*L
      ZC=NT*RTZ*SGN
      KMIN(L)=NINT(ZC-ZMX)
      KMAX(L)=NINT(ZC+ZMX)
      IF(KMAX(L)-KMIN(L)+1.GT.MZ) GOTO 920
      NOUT2(L)=0
      DO 240 N=1,NP
      IZ=NINT(ZC+ZZ(N,L))-KMIN(L)+1
      IF(IZ.LE.0.OR.IZ.GT.MZ) GOTO 960
      JX=NINT(XY(N,1,L))
      JY=NINT(XY(N,2,L))
      IF(ABS(JX).GT.NX.OR.ABS(JY).GT.NY) THEN
          NOUT2(L)=NOUT2(L)+1
        ELSE
          IQX(JX,IZ,L)=IQX(JX,IZ,L)+1
          IQX(JY,IZ,L)=IQY(JY,IZ,L)+1
          IF(IQM.LT.IQX(JX,IZ,L)) IQM=IQX(JX,IZ,L)
          IF(IQM.LT.IQY(JY,IZ,L)) IQM=IQY(JY,IZ,L)
        ENDIF
  240 CONTINUE
  260 CONTINUE
      K00=NINT(MAX(MT2,-MT1)*RTZ+ZMX)
      K01=MIN(K00,(LLIN-MRGNL-2)/4)
      IK0(1)=MRGNL+2*K01+1
      IK0(2)=IK0(1)+1
      NQ0=(IQM+8)/9
      DO 280 I=1,NLIN
  280 PAGE(I)=' '
      WRITE(PAGE,300) NT,NT*DT,
     *   DXYZ(1),(NQ0*J,J=0,9),
     *   DXYZ(2),(MARK(J,1),J=1,10),NOUT2(1),
     *   DXYZ(3),(MARK(J,2),J=1,10),NOUT2(2)
  300 FORMAT('1*** BEAM PROFILE AT NT=',I4,'  T=',1PD9.2,'(M)',/,
     * 3X,'DX=',1PD9.2,'(M)     UP TO',10I5,5X,'OUT OF PLOT',/,
     * 3X,'DY=',1PD9.2,'(M)    BEAM#1',10(4X,A1),5X,I6,5X,/,
     * 3X,'DZ=',1PD9.2,'(M)    BEAM#2',10(4X,A1),5X,I6,5X)
      DO 380 IXY=1,2
      DO 350 I=1,4
  350 PAGE(IXY0(IXY)-2+I)(2:2)=LXYZ(IXY)(I:I)
      DO 370 J=-NXY(IXY),NXY(IXY)
      WRITE(PAGE(IXY0(IXY)-J)(3:5),360) J
  360 FORMAT(I3)
  370 CONTINUE
  380 CONTINUE
      DO 450 K=-K01,K01
      K1=IK0(1)+K*2
      K2=K1+1
      IF(MOD(K,5).EQ.0) GOTO 410
      PAGE(IB0)(K1:K2)='--'
      PAGE(IB1)(K1:K2)='--'
      PAGE(IB2)(K1:K2)='--'
      GOTO 450
  410 PAGE(IB0)(K1:K2)='II'
      PAGE(IB1)(K1:K2)='II'
      PAGE(IB2)(K1:K2)='II'
      LWORK='   '
      WRITE(LWORK,420) K
  420 FORMAT(I3)
      DO 430 I=1,3
      PAGE(IB2+I)(K1:K1)=LWORK(I:I)
  430 PAGE(IB2+I)(K2:K2)=LWORK(I:I)
  450 CONTINUE
      PAGE(IB2+3)(MRGNL-4:MRGNL-1)=LXYZ(3)
      DO 530 L=1,2
      DO 525 K=KMIN(L),KMAX(L)
      IK=2*K+IK0(L)
      IF(IK.LE.MRGNL.OR.IK.GT.LLIN) GOTO 525
      IZ=K-KMIN(L)+1
      DO 520 IXY=1,2
      DO 520 J=-NXY(IXY),NXY(IXY)
      IJ=IXY0(IXY)-J
      IF(IXY.EQ.1) THEN
          IQ1=IQX(J,IZ,L)
        ELSE
          IQ1=IQY(J,IZ,L)
        ENDIF
      MK=(IQ1+NQ0-1)/NQ0+1
      PAGE(IJ)(IK:IK)=MARK(MK,L)
  520 CONTINUE
  525 CONTINUE
  530 CONTINUE
C------ TEST PARTICLES ------
      IF(NTS.LE.0) GOTO 650
      LB=1
      SGN=3-2*LB
      DO 630 N=1,NTS
      DO 620 IT=MT1,NT
      IK=2*NINT(SGN*(ZTS0(N)+IT*RTZ))+IK0(LB)
      IF(IK.LE.MRGNL.OR.IK.GT.LLIN) GOTO 620
      DO 610 IXY=1,2
      J=NINT(XYTS(IT-MT1+1,N,IXY))
  610 IF(ABS(J).LE.NXY(IXY)) PAGE(IXY0(IXY)-J)(IK:IK)='X'
  620 CONTINUE
  630 CONTINUE
C------ EJECT ------
  650 WRITE(6,660) (PAGE(I),I=1,NLIN)
  660 FORMAT(A133)
C------ GRAPHIC
  700 IF(LBPRFL.NE.2.AND.LBPRFL.NE.3) RETURN
      L1=KBPRFL
      L2=KBPRFL
      IF(KBPRFL.GE.3) L1=1
      IF(KBPRFL.GE.3) L2=2
      DO 800 L=L1,L2
      SGN=3-2*L
      T0=NT*DT/SIG(3)
      SMX=ROUND(2.0*ZMX*DXYZ(3)/SIG(3),2)
      XYMAX=3.0
      IF(L.EQ.1) TTL='PROFILE OF BEAM#1   '
      IF(L.EQ.2) TTL='PROFILE OF BEAM#2   '
      IF(KBPRFL.EQ.4) TTL='PROFILE OF BEAM#1#2 '
      DO 790 IXY=1,2
      IF(IXY.EQ.1.AND..NOT.(KBPRFL.EQ.4.AND.L.EQ.2)) THEN
          CALL TDHEAD
          WRITE(IFLTD,710) TTL(1:19),T0
  710     FORMAT(' TITLE TOP ',1H',A,' AT T/SIGZ=',F6.3,1H')
        ENDIF
      WWINDY=3.5
      IF(IXY.EQ.1) THEN
          WINDY1=4.5
        ELSE
          WINDY1=1
        ENDIF
      WRITE(IFLTD,720) WINDY1,WINDY1+WWINDY,-SMX,SMX,-XYMAX,XYMAX
  720 FORMAT('SET FONT DUPLEX',/,
     *  'SET WINDOW X FROM 2 TO 10.5',/,
     *  'SET WINDOW Y FROM ',F5.1,' TO ',F5.1,/,
     *  'SET LIMIT X FROM ',F7.3,' TO ',F7.3,/,
     *  'SET LIMIT Y FROM ',F7.3,' TO ',F7.3)
      IF(L.EQ.1.OR.KBPRFL.NE.4) THEN
          IF(IXY.EQ.1) WRITE(IFLTD,730)
  730     FORMAT('SET LABELS TOP ON;SET LABELS BOTTOM OFF',/,
     *      'TITLE LEFT ''X/SIGX1''')
          IF(IXY.EQ.2) WRITE(IFLTD,740)
  740     FORMAT('SET LABELS TOP OFF;SET LABELS BOTTOM ON',/,
     *      'TITLE LEFT ''Y/SIGY1'';TITLE BOTTOM ''S/SIGZ1''')
        ENDIF
      SCLH=DXYZ(3)/SIG(3)
      SCLV=DXYZ(IXY)/SIG(IXY)
      NPP=NP/MBPRFL
      N2=0
  750 N1=N2+1
      N2=MIN(N1+1000,NPP)
c        write(6,*) sgn,t0,zz(n1*mbprfl,l),ixy,l
      WRITE(IFLTD,760) (SGN*(ZZ(N*MBPRFL,L)*SCLH+T0),
     *              XY(N*MBPRFL,IXY,L)*SCLV,N=N1,N2)
  760 FORMAT(3(1PD11.4,1X,1PD11.4,';'))
      WRITE(IFLTD,770)
  770 FORMAT('PLOT')
      IF(N2.LT.NPP) GOTO 750
C
      IF(NTS.LE.0) GOTO 790
      IF(NT-MT1.LE.0) GOTO 790
      SGN=1
      DO 780 N=1,NTS
      WRITE(IFLTD,760) (SGN*(ZTS0(N)*SCLH+IT*DT/SIG(3)),
     *  XYTS(IT-MT1+1,N,IXY)*SCLV,IT=MT1,NT)
      WRITE(IFLTD,775)
  775 FORMAT(' JOIN 1')
  780 CONTINUE
  790 CONTINUE
  800 CONTINUE
      RETURN
C------ ERROR ------
  900 WRITE(6,910)
  910 FORMAT(' (SUBR.BPRFL) ARRAY "PAGE" SHORT. NO BEAM PROFILE PLOT.')
      GOTO 940
  920 WRITE(6,930)
  930 FORMAT(' (SUBR.BPRFL) ARRAY "IQX,IQY" SHORT.',
     * ' NO BEAM PROFILE PLOT.')
  940 LBPRFL=0
      RETURN
  960 WRITE(6,970)
  970 FORMAT(' (SUBR.BPRFL) PROGRAM ERROR. CALL THE PROGRAMMER.')
      STOP
      END
