C   15/05/87 712221623  MEMBER NAME  CFTRV    *.FORT     M  FORTRAN77   0000
C                                                                       0000
C       FFT SUBROUTINE  5-JUN-1987  K. OIDE                             0000
C                                                                       0000
C       SUBROUTINE CFTRV(CA,N,MDIM,CONJ)                                0000
C                                                                       0000
C       FAST FOURIE TRANSFORMATION OF A COMPLEX (N,N) MATRIX CA         0000
C                                                                       0000
C       CALL CFTRV(CA,N,MDIM,CONJ)                                      0000
C                                                                       0000
C       CA      INPUT/OUTPUT MATRIX (OUTPUT IS TRANSPOSED)              0000
C       N       SIZE OF CA,CB                                           0000
C       MDIM    LENGTH OF TH FIRST DIMENSION OF CA AND CB               0000
C                                                                       0000
C       IF(CONJ)THEN                                                    0000
C         CB(L,J) = SUM C(K,L)*EXP(-I*2*PI*(J-1)*(K-1)/N )              0000
C       ELSE                                                            0000
C         CB(L,J) = SUM C(K,L)*EXP( I*2*PI*(J-1)*(K-1)/N )              0000
C       ENDIF                                                           0000
C                                                                       0000
        SUBROUTINE CFTRV(CA,N,MDIM,CONJ)                                0000
        IMPLICIT REAL*8 (A,B,D-H,O-Z)                                   0000
        IMPLICIT COMPLEX*16 (C)                                         0000
        PARAMETER (IDIM=16)                                             0000
        LOGICAL CONJ                                                    0000
        DIMENSION CA(MDIM,*),M(IDIM),CEX(IDIM)                          0000
        DATA M                                                          0000
     *  /1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768   0000
     *  /                                                               0000
        DATA CEX /                                                      0000
     *    ( -1.D+00               ,   0.D+00              ),            0000
     *    (  0.D+00               ,   1.00000000000000D+00),            0000
     *    (  0.707106781186548D+00,  0.707106781186548D+00),            0000
     *    (  0.923879532511287D+00,  0.382683432365090D+00),            0000
     *    (  0.980785280403230D+00,  0.195090322016128D+00),            0000
     *    (  0.995184726672197D+00,   9.80171403295606D-02),            0000
     *    (  0.998795456205172D+00,   4.90676743274180D-02),            0000
     *    (  0.999698818696204D+00,   2.45412285229123D-02),            0000
     *    (  0.999924701839145D+00,   1.22715382857199D-02),            0000
     *    (  0.999981175282601D+00,   6.13588464915447D-03),            0000
     *    (  0.999995293809576D+00,   3.06795676296598D-03),            0000
     *    (  0.999998823451702D+00,   1.53398018628477D-03),            0000
     *    (  0.999999705862882D+00,   7.66990318742704D-04),            0000
     *    (  0.999999926465718D+00,   3.83495187571396D-04),            0000
     *    (  0.999999981616429D+00,   1.91747597310703D-04),            0000
     *    (  0.999999995404107D+00,   9.58737990959773D-05)             0000
     *  /                                                               0000
                                                                        0000
        DO 10 I=1,IDIM-1                                                0000
          IF(N .EQ. M(I+1))THEN                                         0000
            LN=I                                                        0000
            GO TO 1                                                     0000
          ENDIF                                                         0000
10      CONTINUE                                                        0000
        N=0                                                             0000
        RETURN                                                          0000
                                                                        0000
1       DO 20 I=1,N                                                     0000
          KI=I-1                                                        0000
          IBINV=1                                                       0000
          DO 30 J=1,LN                                                  0000
CHITAC           JJ=KI .AND. M(J)                                       0000
            JJ=IAND(KI,M(J))                                            0000
            IF( JJ .NE. 0 )THEN                                         0000
              IBINV=IBINV+M(LN-J+1)                                     0000
            ENDIF                                                       0000
30        CONTINUE                                                      0000
          IF( IBINV .GT. I )THEN                                        0000
*VOPTION NOFVAL                                                         0000
            DO 50 J=1,N                                                 0000
              CH=CA(J,IBINV)                                            0000
              CA(J,IBINV)=CA(J,I)                                       0000
              CA(J,I)=CH                                                0000
50          CONTINUE                                                    0000
          ENDIF                                                         0000
20      CONTINUE                                                        0000
                                                                        0000
        DO 110 I=1,LN                                                   0000
          CW=(1.D0,0.D0)                                                0000
          IF(CONJ)THEN                                                  0000
            CW1=CONJG(CEX(I))                                           0000
          ELSE                                                          0000
            CW1=CEX(I)                                                  0000
          ENDIF                                                         0000
          DO 120 J=1,M(I)                                               0000
            DO 130 K=0,N-1,M(I+1)                                       0000
              KA=K+J                                                    0000
              KB=KA+M(I)                                                0000
*VOPTION NOFVAL                                                         0000
              DO 140 L=1,N                                              0000
                CH=CW*CA(L,KB)                                          0000
                CA(L,KB)=CA(L,KA)-CH                                    0000
                CA(L,KA)=CA(L,KA)+CH                                    0000
140           CONTINUE                                                  0000
130         CONTINUE                                                    0000
            CW=CW*CW1                                                   0000
120       CONTINUE                                                      0000
110     CONTINUE                                                        0000
                                                                        0000
        DO 210 I=1,N                                                    0000
*VOPTION NOFVAL                                                         0000
          DO 220 J=I+1,N                                                0000
            CH=CA(J,I)                                                  0000
            CA(J,I)=CA(I,J)                                             0000
            CA(I,J)=CH                                                  0000
220       CONTINUE                                                      0000
210     CONTINUE                                                        0000
        RETURN                                                          0000
        END                                                             0000
