C   14/04/87 910031317  MEMBER NAME  CMPTN2   *.FORT     M  FORTRAN77   0000
C******************** CMPTN2 *******************************************0000
      SUBROUTINE CMPTN2(KFLD,ENG,IXM,IYM,NP,NX,NY,NSBIN1,               0000
     %     MSQ,SBINW,ISQN,ISQK,ISC,                                     0000
     %     MCPSQ,NCPSQ,CPB2,CPBN,GGB2,GGBN,                             0000
     %     ICPQN,ICPQK,ICPC,MAXPH,EPH,IDPH,THIN)                        0000
      INCLUDE '@SHISCM'
      REAL*8 ENG(NP,2)                                                  0000
      INTEGER IXM(2,2),IYM(2,2)                                         0000
      REAL*4 SBINW(NSBIN1)                                              0000
      INTEGER ISQN(MSQ,2),ISQK(MSQ,2),ISC(NX*NY,2)                      0000
      REAL*4 CPB2(NSBIN1,NSBIN1,2),CPBN(NSBIN1,2),EPH(MAXPH,2)          0000
      REAL*4 GGB2(NSBIN1,NSBIN1),GGBN(NSBIN1)                           0000
      INTEGER NCPSQ(2),ICPQN(MCPSQ,2),ICPQK(MCPSQ,2),ICPC(NX*NY,2),     0000
     %        IDPH(MAXPH,2)                                             0000
      LOGICAL LIN1                                                      0000
C                                                                       0000
      WEIGHT=1.0/THIN                                                   0000
      FACE=NSBIN/(EBMAX-EBMIN)*0.9999E0                                 0000
      FACP=NSBIN/(CBMAX-CBMIN)*0.9999E0                                 0000
      FACS=NSBIN/(CSBMAX-CSBMIN)*0.9999E0                               0000
      FACGS=NSBIN/(GSBMAX-GSBMIN)*0.9999E0                              0000
      DO 500 L1=1,2                                                     0000
      L2=3-L1                                                           0000
C COMPTON LUMINOSITY BETWEEN BEAM #L1 AND PHOTONS FROM BEAM #L2         0000
      IF(NSQ(L1).EQ.0.OR.NCPSQ(L2).EQ.0) GOTO 500                       0000
      IF(KFLD.EQ.4) THEN                                                0000
          IX1=1                                                         0000
          IX2=1                                                         0000
        ELSE                                                            0000
          IX1=IXM(1,L1)                                                 0000
          IX2=IXM(2,L1)                                                 0000
        ENDIF                                                           0000
      IY1=IYM(1,L1)                                                     0000
      IY2=IYM(2,L1)                                                     0000
      DO 100 K=1,NSBIN                                                  0000
  100 SBINW(K)=0                                                        0000
      DO 300 J=IY1,IY2                                                  0000
      DO 300 I=IX1,IX2                                                  0000
      IS1=ISC(I+NX*(J-1),L1)                                            0000
      IF(IS1.EQ.0) GOTO 300                                             0000
      IS20=ICPC(I+NX*(J-1),L2)                                          0000
      IF(IS20.EQ.0) GOTO 300                                            0000
  180 N1=ISQN(IS1,L1)                                                   0000
      E1=ENG(N1,L1)                                                     0000
      KBIN1=INT((E1-EBMIN)*FACE)+1                                      0000
      LIN1=KBIN1.GE.1.AND.KBIN1.LE.NSBIN                                0000
      IS2=IS20                                                          0000
  200 N2=ICPQN(IS2,L2)                                                  0000
      E2=EPH(IDPH(N2,L2),L2)                                            0000
      SB=(E1*E2-CSBMIN)*FACS                                            0000
      KBIN=INT(SB)+1                                                    0000
      IF(KBIN.GE.1.AND.KBIN.LE.NSBIN) SBINW(KBIN)=SBINW(KBIN)+WEIGHT    0000
      IF(LIN1) THEN                                                     0000
          KBIN2=INT((E2-CBMIN)*FACP)+1                                  0000
          IF(KBIN2.GE.1.AND.KBIN2.LE.NSBIN)                             0000
     %      CPB2(KBIN1,KBIN2,L1)=CPB2(KBIN1,KBIN2,L1)+WEIGHT            0000
        ENDIF                                                           0000
      IS2=ICPQK(IS2,L2)                                                 0000
      IF(IS2.NE.0) GOTO 200                                             0000
      IS1=ISQK(IS1,L1)                                                  0000
      IF(IS1.NE.0) GOTO 180                                             0000
  300 CONTINUE                                                          0000
      DO 320 K=1,NSBIN                                                  0000
  320 CPBN(K,L1)=CPBN(K,L1)+SBINW(K)                                    0000
  500 CONTINUE                                                          0000
C-- GAMMA-GAMMA SPECTRUM                                                0000
      WEIGHT=1.0/THIN**2                                                0000
      IF(NCPSQ(1).EQ.0.OR.NCPSQ(2).EQ.0) GOTO 800                       0000
      DO 510 K=1,NSBIN                                                  0000
  510 SBINW(K)=0                                                        0000
      DO 700 J=1,NY                                                     0000
      DO 700 I=1,NX                                                     0000
      IS1=ICPC(I+NX*(J-1),1)                                            0000
      IF(IS1.EQ.0) GOTO 700                                             0000
      IS20=ICPC(I+NX*(J-1),2)                                           0000
      IF(IS20.EQ.0) GOTO 700                                            0000
  580 N1=ICPQN(IS1,1)                                                   0000
      E1=EPH(IDPH(N1,1),1)                                              0000
      KBIN1=INT((E1-CBMIN)*FACP)+1                                      0000
      LIN1=KBIN1.GE.1.AND.KBIN1.LE.NSBIN                                0000
      IS2=IS20                                                          0000
  600 N2=ICPQN(IS2,2)                                                   0000
      E2=EPH(IDPH(N2,2),2)                                              0000
      SB=(E1*E2-GSBMIN)*FACGS                                           0000
      KBIN=INT(SB)+1                                                    0000
      IF(KBIN.GE.1.AND.KBIN.LE.NSBIN) SBINW(KBIN)=SBINW(KBIN)+WEIGHT    0000
      IF(LIN1) THEN                                                     0000
          KBIN2=INT((E2-CBMIN)*FACP)+1                                  0000
          IF(KBIN2.GE.1.AND.KBIN2.LE.NSBIN)                             0000
     %      GGB2(KBIN1,KBIN2)=GGB2(KBIN1,KBIN2)+WEIGHT                  0000
        ENDIF                                                           0000
      IS2=ICPQK(IS2,2)                                                  0000
      IF(IS2.NE.0) GOTO 600                                             0000
      IS1=ICPQK(IS1,1)                                                  0000
      IF(IS1.NE.0) GOTO 580                                             0000
  700 CONTINUE                                                          0000
      DO 720 K=1,NSBIN                                                  0000
  720 GGBN(K)=GGBN(K)+SBINW(K)                                          0000
  800 RETURN                                                            0000
      END                                                               0000
