C   14/04/87 706021358  MEMBER NAME  CWERF    *.FORT     M  FORTRAN77   0000
C******************** CWERF ****************************************    0000
      FUNCTION CWERF(CMPZ)                                                0000
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 CMPZ 
      COMPLEX*16 CWERF                                                  0000
      LOGICAL B                                                         0000
      DATA CONST/1.12837 91670 9551D0/                                  0000
      XX=REAL(CMPZ)                                                       0000
      YY=IMAG(CMPZ)                                                       0000
      X=ABS(XX)                                                         0000
      Y=ABS(YY)                                                         0000
      IF(Y .LT. 4.29D0 .AND. X .LT. 5.33D0) GO TO 1                     0000
      H=0.                                                              0000
      NC=0                                                              0000
      NU=8                                                              0000
      ALAMDA=0.                                                         0000
      B=.TRUE.                                                          0000
      GO TO 2                                                           0000
    1 S=(1D0-Y/4.29D0)*SQRT(1D0-X**2/28.41D0)                           0000
      H=1.6D0*S                                                         0000
      H2=2D0*H                                                          0000
      NC=6+INT(23D0*S)                                                  0000
      NU=9+INT(21D0*S)                                                  0000
      ALAMDA=H2**NC                                                     0000
      B= ALAMDA .EQ. 0D0                                                0000
    2 R1=0D0                                                            0000
      R2=0D0                                                            0000
      S1=0D0                                                            0000
      S2=0D0                                                            0000
      N=NU+1                                                            0000
    3 N=N-1                                                             0000
      FN=N+1                                                            0000
      T1=Y+H+FN*R1                                                      0000
      T2=X-FN*R2                                                        0000
      C=0.5D0/(T1**2+T2**2)                                             0000
      R1=C*T1                                                           0000
      R2=C*T2                                                           0000
      IF(H .LE. 0.0 .OR. N .GT. NC) GO TO 4                             0000
      T1=ALAMDA+S1                                                      0000
      S1=R1*T1-R2*S2                                                    0000
      S2=R2*T1+R1*S2                                                    0000
      ALAMDA=ALAMDA/H2                                                  0000
    4 IF(N .GT. 0) GO TO 3                                              0000
      IF(B) GO TO 6                                                     0000
      RS1=S1                                                            0000
      RS2=S2                                                            0000
      GO TO 7                                                           0000
    6 RS1=R1                                                            0000
      RS2=R2                                                            0000
    7 RS1=CONST*RS1                                                     0000
      IF(Y .EQ. 0D0) RS1=EXP(-X**2)                                     0000
      CWERF=DCMPLX(RS1,CONST*RS2)                                       0000
      IF(YY .LT. 0D0) GO TO 8                                           0000
      IF(XX .LT. 0D0) CWERF=CONJG(CWERF)                                0000
      RETURN                                                            0000
    8 CWERF=2D0*EXP(-DCMPLX(X,Y)**2)-CWERF                              0000
      IF(XX .GT. 0D0) CWERF=CONJG(CWERF)                                0000
      RETURN                                                            0000
      END                                                               0000
