C   14/04/87 909261138  MEMBER NAME  LUMINT   *.FORT        FORTRAN77   0000
C******************** LUMINT *******************************************0000
      SUBROUTINE LUMINT(KFLD,Q,QE,IXM,IYM,NX,NY,ALUM1,ALUM2,            0000
     %   ENHT,LENHZ,ENHZ,IZMIN,IZMAX,IZMM1,NPIZ,                        0000
     %   LSHIST,SCM,SCM1,MMOM,LSPIN,POLS,POLZ)                          0000
      REAL*8 Q(NX*NY,2),QE(NX*NY,2,MMOM)                                0000
      REAL*4 POLZ(NX*NY,*)                                              0000
      REAL*4 ENHZ(IZMIN:IZMAX+1,2)                                      0000
      REAL*8 SCM(MMOM),SCM1(MMOM),POLS(2)                               0000
      REAL*8 SUM1,SUM2,SUMSUM,SUMZ1,ALUM1,ALUM2,SUMP                    0000
      INTEGER IXM(2,2),IYM(2,2),IZMM1(2,2),LSPIN(2)                     0000
      INTEGER NPIZ(IZMIN:IZMAX+1,2)                                     0000
      LOGICAL INSIDE                                                    0000
C                                                                       0000
      SUM1=0D0                                                          0000
      SUM2=0D0                                                          0000
      IY1=MAX(IYM(1,1),IYM(1,2))                                        0000
      IY2=MIN(IYM(2,1),IYM(2,2))                                        0000
      IF(IY1.GT.IY2) RETURN                                             0000
      IF(KFLD.EQ.4) GOTO 220                                            0000
      IX1=MAX(IXM(1,1),IXM(1,2))                                        0000
      IX2=MIN(IXM(2,1),IXM(2,2))                                        0000
      IF(IX1.GT.IX2) RETURN                                             0000
      DO 200 J=IY1,IY2                                                  0000
      INSIDE=J.GT.1.AND.J.LT.NY                                         0000
      DO 200 I=IX1,IX2                                                  0000
      SUM1=SUM1+Q(I+NX*(J-1),1)*Q(I+NX*(J-1),2)                         0000
      IF(I.GT.1.AND.I.LT.NX)                                            0000
     %   SUM2=SUM2+(Q(I+1+NX*(J-1),1)-Q(I-1+NX*(J-1),1))*               0000
     %             (Q(I+1+NX*(J-1),2)-Q(I-1+NX*(J-1),2))                0000
      IF(INSIDE)                                                        0000
     %   SUM2=SUM2+(Q(I+NX*J,1)-Q(I+NX*(J-2),1))*                       0000
     %             (Q(I+NX*J,2)-Q(I+NX*(J-2),2))                        0000
  200 CONTINUE                                                          0000
      GOTO 260                                                          0000
  220 DO 240 J=IY1,IY2                                                  0000
      SUM1=SUM1+Q(J,1)*Q(J,2)                                           0000
      IF(J.GT.1.AND.J.LT.NY)                                            0000
     %   SUM2=SUM2+(Q(J+1,1)-Q(J-1,1))*(Q(J+1,2)-Q(J-1,2))              0000
  240 CONTINUE                                                          0000
  260 ALUM1=ALUM1+SUM1                                                  0000
      ALUM2=ALUM2+SUM2                                                  0000
      SUMSUM=SUM1+SUM2/48D0                                             0000
      ENHT=ENHT+SUMSUM                                                  0000
      IF(LENHZ.LE.0) GOTO 320                                           0000
      DO 300 L=1,2                                                      0000
      SUMZ1=SUMSUM/(NPIZ(IZMM1(2,L)+1,L)-NPIZ(IZMM1(1,L),L))            0000
      DO 280 IZ=IZMM1(1,L),IZMM1(2,L)                                   0000
  280 ENHZ(IZ,L)=ENHZ(IZ,L)+SUMZ1*(NPIZ(IZ+1,L)-NPIZ(IZ,L))             0000
  300 CONTINUE                                                          0000
  320 IF(LSHIST.LT.0) GOTO 500                                          0000
      DO 340 II=1,MMOM                                                  0000
  340 SCM1(II)=0D0                                                      0000
      DO 370 II=1,MMOM                                                  0000
      IF(KFLD.EQ.4) THEN                                                0000
          DO 350 J=IY1,IY2                                              0000
  350     SCM1(II)=SCM1(II)+QE(J,1,II)*QE(J,2,II)                       0000
        ELSE                                                            0000
          DO 360 J=IY1,IY2                                              0000
          DO 360 I=IX1,IX2                                              0000
  360     SCM1(II)=SCM1(II)+QE(I+NX*(J-1),1,II)*QE(I+NX*(J-1),2,II)     0000
        ENDIF                                                           0000
  370 CONTINUE                                                          0000
      DO 380 II=1,MMOM                                                  0000
  380 SCM(II)=SCM(II)+SCM1(II)                                          0000
      GOTO 500                                                          0000
C                                                                       0000
  500 DO 560 L=1,2                                                      0000
      LS=LSPIN(L)                                                       0000
      IF(LS.EQ.0) GOTO 560                                              0000
      L2=3-L                                                            0000
      SUMP=0D0                                                          0000
      IF(KFLD.EQ.4) THEN                                                0000
          DO 520 J=IY1,IY2                                              0000
  520     SUMP=SUMP+POLZ(J,LS)*Q(J,L2)                                  0000
        ELSE                                                            0000
          DO 540 J=IY1,IY2                                              0000
          DO 540 I=IX1,IX2                                              0000
  540     SUMP=SUMP+POLZ(I+NX*(J-1),LS)*Q(I+NX*(J-1),L2)                0000
        ENDIF                                                           0000
      POLS(LS)=POLS(LS)+SUMP                                            0000
  560 CONTINUE                                                          0000
      RETURN                                                            0000
      END                                                               0000
