      SUBROUTINE PAIRLL(NTUNE,NBOOST,LOCAL,NFLDEX,NP,IXY,XY0,XY,
     %    ENG,NX,NY,Q,NPZ0,NPZ,ENGY,
     %    NLEP,MAXLEP,ELEMIN,ELEMAX,THINLE,
     %    IDLE,LEOR,EELE,XYLE,CONSLL,GAM,ANGMIN,
     %    DXYZ,DT,BLEND,UPSLN,IRR)
C***********************************************************************
C  GENERATE E+E- PAIR FROM BEAM#1 BY LANDAU-LIFSHITZ PROCESS
C  CROSS SECTION FORMULA
C    using real photon approximation
C     create pairs only in forward angle region with FASTLL option.
C               now  FASTLL is standard option since 10-Jan.-1992.
C***********************************************************************
      INCLUDE '@DEBUG'
      REAL*4 XY0(NP,2,2),XY(NP,2,2),ENGY(2),THINLE(3),GAM(2)
     *, UPSLN(NX*NY,2)
      INTEGER IXY(NP,2),NPZ(2),NPZ0(2)
      REAL*8 Q(NX*NY,2),ENG(NP,2)
      INTEGER IDLE(MAXLEP),LEOR(MAXLEP)
      REAL*4 EELE(MAXLEP),XYLE(MAXLEP,2,2),BLEND(2),DXYZ(3)
      DATA PI/3.14159/,PI2/6.28319/
      DATA EMASS/0.5110034D-3/,NCHKYX/1000000/,NCHKMX/1000000/
      DATA NBSTMX/100000/,INIT/0/
ccc      DATA NTRYMX/100000/
      DATA NTRYMX/100000/
CREAL8
      REAL*8 CSPAIR,CS,COSMIN,YM,YP,YB,YG1,YG2,ANGMIN
      REAL*8 SN,ANGCUT
      REAL*8 CSB,EPAIR,PPAIR,BPAIR,SNB2,ENGLE
      REAL*8 YMMIN,YMMIN1,SMIN,EGVRTL
CREAL8
      real*4 dum1,dum2

      IF(INIT.EQ.0) THEN
CCC    YMMIN = 0.5*ELEMIN*(1.-COSMIN)
      SMIN   = (EMASS/ENGY(1))**2
      COSMIN = 1.D0 - 0.5D0*ANGMIN**2
      YMMIN  = 0.25D0*DBLE(ELEMIN)*ANGMIN**2
      IF(SMIN.GT.YMMIN)  YMMIN =SMIN
      YMMIN1 = YMMIN
CFASTLL
               YMMIN1 = 0.5*ELEMIN
CFASTLL
       INIT  = 1
        if(kbeta.eq.1) then
          cosmin  = EMASS/ENGY(1)
          COSMIN = 1.D0 - 0.5D0*cosmin**2
          ymmin   = smin
          ymmin1  = ymmin
        endif
      ENDIF
C
      IF(ELEMIN*ENGY(1).LT.10.E-3) THEN
       NTRYMX = 100000
        ELSE
       NTRYMX = 10000
      ENDIF
C
      L1=1
      L2=3-L1
C---Loop over electrons in the beam#1
      DO 300 N=NPZ0(L1),NPZ(L1)
      II=IXY(N,L1)
      IF(II.LE.0) GOTO 300
      IF(Q(II,L2).LE.0) GOTO 300
      TLMNS = TLMNS + Q(II,L2)
CNEWNEW
      CM=Q(II,L2)*CONSLL*THINLE(3)
      TCRSLL = TCRSLL + CM
      if(thinle(3).gt.0.) wgtlep=1./thinle(3)
      M  = IFIX(CM)
      DM = CM - M
      IF( RAN(IRR).LT.DM ) M = M + 1

cc      IF(DM.GT.RAN(IRR) ) M = M + 1 ;29989  in  5 MeV < E < 10 MeV of Paper(E500)
cc      IF(DM.LE.RAN(IRR) ) M = M + 1 ;23028
cc      IF(DM.GT.0.5) M = M + 1       ;33952
cc    for ignoring  DM                ;14872

      IF(M.LE.0) GO TO 300
CPRT       PRINT *,'**PAIRLL-- NLEP,M=',NLEP,M
CNEWNEW
      NREP=0
  120 NREP=NREP+1
      IF(NLEP+2*M.LE.MAXLEP) GOTO 140
      CALL CPRSLE(NLEP,MAXLEP,LEOR,EELE,XYLE,THINLE,IRR)
      IF(NREP.LE.2) GOTO 120
      WRITE(6,130)
  130 FORMAT(' (SUBR.PAIRLL)   ##### PROGRAM ERROR #####')
      STOP
C---
  140 CONTINUE
C---
      DO 260 I=1,2*M
CANGCHK       IANCHK = 1
CANGCHK       IF(IANCHK.EQ.1) GO TO 1919
      NCHK  = 0
      NCHKY = 0
      NM = 0
261   CONTINUE
      NM = NM + 1
      IF(NM.GT.100000) GO TO 260
CC
cdebug      PRINT *,'** YG1,YG2,CS =',YG1,YG2,CS,' YG1*YG2=',YG1*YG2,' NM=',NM
CC
      CS   = CSPAIR(IRR,COSMIN)
CFASTLL
              CS   = ABS( CS )
CFASTLL
      YM   = 0.5*ELEMIN*(1.-CS)
      IF(KBETA.EQ.0.OR.YMMIN.GT.YM) THEN
      YG2  = EGVRTL(YMMIN,IRR)
       ELSE
      YG2  = EGVRTL(YM,IRR)
      ENDIF
C- Check YG2 > YM
      IF(YG2.LE.YM) THEN
      NCHKY= NCHKY+ 1
       IF(NCHKY.GT.NCHKYX) THEN
C       PRINT *,'!!PAIRLL--YG2<YM !!,NCHKY,YG2,YM,CS=',NCHKY,YG2,YM,CS
         NENGLL = NENGLL + 1
        GO TO 260
       ENDIF
      GO TO 261
      ENDIF
C---
      YP   = 0.5D0*ELEMIN*(1.D0+CS)
      YB   = YG2*YP/(YG2 - YM)
C Check YB < 1.
      IF(YB.GT.1.D0) THEN
      NCHK = NCHK + 1
      IF(NCHK.GT.NCHKMX) THEN
      PRINT *,'!!PAIRLL --YB > 1.  !!, YB=',YB,' YG2,YM=',YG2,YM
      GO TO 260
      ENDIF
      GO TO 261
      ENDIF
C YG1
      IF(KBETA.EQ.0.OR.YMMIN1.GT.YB) THEN
      YG1  = EGVRTL(YMMIN1,IRR)
       ELSE
      YG1  = EGVRTL(YB,IRR)
      ENDIF
C- Check YG1 > YB
      IF(YG1.LT.YB) THEN
      NCHKY= NCHKY+ 1
      IF(NCHKY.GT.NCHKYX) THEN
C     PRINT *,'!!PAIRLL --YG1 < YB !!, NCHKY,YG1,YB=',NCHKY,YG1,YB
         NENGLL = NENGLL + 1
      GO TO 260
      ENDIF
      GO TO 261
      ENDIF
C----
      IF( (YG1*YG2).LT.SMIN  ) THEN
        if(kbeta.eq.0) then
         GO TO 260
           else
         GO TO 261
         endif
      ENDIF
C----
CPRT       PRINT *,'     M,CS,YG1,YG2=',I,CS,YG1,YG2
C----
      ENGLE= 2.D0*YG1*YG2/( YG1*(1.D0-CS)+YG2*(1.D0+CS) )
      CSB  = CS
CBETA
      if(kbeta.eq.1) then
       EPAIR = ENGLE*ENGY(1)                                                 
       PPAIR = SQRT( EPAIR**2 - 0.511D-3**2 )                              
       BPAIR = PPAIR/EPAIR                                                 
       SNB2  = 1.D0-BPAIR**2*CS**2                                            
       SN   = 1.D0 - CS**2
       IF(RAN(IRR).GT.SN/SNB2) GO TO 261
       CSB  = CS*BPAIR
       ANGLL = 0.0
      endif
CBETA
CCBOOST
      IF(NBOOST.EQ.1) THEN
      CALL CSBOOT(IRR, CSB,YG1,YG2,IRTN)
       IF(IRTN.NE.0) then
         if(kbeta.eq.0) then
          GO TO 260
           else
          GO TO 261
          endif
       endif
      ENDIF
CCBOOST
CCC      ENGLE= 2.*YG1*YG2/( YG1*(1.-CS)+YG2*(1.+CS) )
C---
CDBG       IF(ENGLE.LT.ELEMIN) THEN
CDBG        PRINT *,'!!! PAIRLL !!!, ENGLE,YG1,YG2,CS=',ENGLE,YG1,YG2,CS
CDBG        GO TO 260
CDBG       ENDIF
C--
      IF(ENGLE.LT.ELEMIN.OR.ENGLE.GE.ELEMAX) GO TO 260
C--minimum angle cut  due to electron mass.
      SN   = 1.D0 - CS**2
      SN   = SQRT( SN )
ccc      ANGCUT = 0.70/GAM(1)/ENGLE
      ANGCUT = ANGLL/GAM(1)/ENGLE
CMAS105            ANGCUT = 1.05/GAM(1)/ENGLE
      IF( kbeta.eq.0.and.SN.LE.ANGCUT ) GO TO 260
C******* 
      IF(LOCAL.EQ.0.OR.NFLDEX.EQ.0) THEN
C******* 
c      write(6,*) '17'
        CALL QTVRTL(RTVRT1,YTV1,GAM(1),YG1,IRR)
        CALL QTVRTL(RTVRT2,YTV2,GAM(2),YG2,IRR)
c      write(6,*) '18'
C-- Effect of the external ele.magnetic field.
        IF(NFLDEX.EQ.0) THEN
         YTVMN1 = YG1*(      UPSLN(II,1)/YG1 )**(1./3.)
         YTVMN2 = YG2*(      UPSLN(II,2)/YG2 )**(1./3.)
CNEWEXT          YTVMN1 = YG1*(  1.5*UPSLN(II,1)/YG1 )**(1./3.)
CNEWEXT          YTVMN2 = YG2*(  1.5*UPSLN(II,2)/YG2 )**(1./3.)
CBAIER           YTVMN1 = YG1*( 1. + UPSLN(II,1)/YG1 )**(1./3.)
CBAIER           YTVMN2 = YG2*( 1. + UPSLN(II,2)/YG2 )**(1./3.)
         IF(YTVMN1.GT.0.) CALL HCUM1('RYGT',YTV1/YTVMN1,wgtlep)
         IF(YTVMN2.GT.0.) CALL HCUM1('RYGT',YTV2/YTVMN2,wgtlep)
         IF(YTV1.LT.YTVMN1.OR.YTV2.LT.YTVMN2) GO TO 260
        ENDIF
C******* 
      ENDIF
C******* 
C--
cc      IF(LOCAL.EQ.0) THEN
CC      IF(LOCAL.EQ.0.AND.RAN(IRR).LT.0.7) THEN
      IF(LOCAL.EQ.0.AND.
     *(NTUNE.NE.2.OR.(NTUNE.EQ.2.AND.RAN(IRR).LT.0.7) ) ) THEN
C--
C-- Non-local intereaction here
      RHO1  = RTVRT1
      RHO2  = RTVRT2
ccc
      PHI  = PI2*RAN(IRR)
      XGAM = XY(N,1,L1)+ RHO1*COS(PHI)/DXYZ(1)
      YGAM = XY(N,2,L1)+ RHO1*SIN(PHI)/DXYZ(2)
ccc
      CSMIN = (-1. + BLEND(1) - XGAM )/RHO2*DXYZ(1)
      CSMAX = (FLOAT(NX+1.) + BLEND(1) - XGAM )/RHO2*DXYZ(1)
      IF(CSMIN.GT.1.0.OR.CSMAX.LT.-1.0) GO TO 260
      SNMIN = (-1. + BLEND(2) - YGAM )/RHO2*DXYZ(2)
      SNMAX = (FLOAT(NY+1.) + BLEND(2) - YGAM )/RHO2*DXYZ(2)
      IF(SNMIN.GT.1.0.OR.SNMAX.LT.-1.0) GO TO 260
cccccc      IF(CSMIN.LT.-1.0) CSMIN=-1.0
cccccc      IF(CSMAX.GT.1.0) CSMAX=1.0
ccc
      NTRY = 0
262   CONTINUE
      NTRY = NTRY + 1
      IF(NTRY.GT.NTRYMX) GO TO 260
ccc
cccccc      COSPHI = CSMIN + (CSMAX-CSMIN)*RAN(IRR)
cccccc      SINPHI = SQRT(1. -COSPHI**2)
cccccc      IF(RAN(IRR).GT.0.5) SINPHI=-SINPHI
      PHI  = PI2*RAN(IRR)
      COSPHI = COS(PHI)
      SINPHI = SIN(PHI)
      IF(COSPHI.LT.CSMIN.OR.COSPHI.GT.CSMAX) GO TO 262
      IF(SINPHI.LT.SNMIN.OR.SINPHI.GT.SNMAX) GO TO 262
ccc
      X2   = XGAM      + RHO2*COSPHI/DXYZ(1)
      Y2   = YGAM      + RHO2*SINPHI/DXYZ(2)
      XXGAM= X2 - BLEND(1)
      IF(XXGAM.LT.0.0.OR.XXGAM.GT.FLOAT(NX)) GO TO 262
      YYGAM= Y2 - BLEND(2)
      IF(YYGAM.LT.0.0.OR.YYGAM.GT.FLOAT(NY)) GO TO 262
CCC
      IX2  = NINT( XXGAM )
      IY2  = NINT( YYGAM )
       IF(IX2.GE.0.AND.IX2.LE.NX.AND.IY2.GE.0.AND.IY2.LE.NY) THEN
        IXY2  = IX2  +1+NX*IY2
         FRACQ = Q(IXY2,L2)/Q(II,L2)
ccc
         call hcum1('LLFR',fracq,wgtlep)
           if(fracq.gt.1.0) then
              wgtlep = wgtlep
              if(NTUNE.EQ.3) wgtlep = fracq*wgtlep
              else
cc            IF(RAN(IRR).GT.FRACQ*1.53) GO TO 260
            IF(RAN(IRR).GT.FRACQ) GO TO 260
           endif
ccc
         ELSE
        GO TO 260
       ENDIF
C--
      ELSE
C--
      XGAM = XY(N,1,L1)
      YGAM = XY(N,2,L1)
C--
      ENDIF
C--note !!! because angular distribution should be symmetrical.
      CS   = ABS( CS )
CANGCHK 1919  CONTINUE
CANGCHK       ENGLE= ELEMIN + (ELEMAX-ELEMIN)*RAN(IRR)
CANGCHK       CS   = 1.0
CANGCHK       XGAM = XY(N,1,L1)
CANGCHK       YGAM = XY(N,2,L1)
CANG100                  CS = 0.995
CANG70                   CS = 0.99755
CANG50                   CS = 0.99875
CANG60                   CS = 0.99820
CANG40                   CS = 0.99920
CANG20                   CS = 0.99980
CANGCHK       IF(ENGLE.LE.0.) THEN
CANGCHK        PRINT *,'!!PAIRLL!!, ELEMIN,ELEMAX,ENGLE=',ELEMIN,ELEMAX,ENGL
CANGCHK       ENDIF
C---
      dum1 = cs
      CALL HCUM1('ANLL',dum1,wgtlep)
      dum1 = DLOG10(ENGLE)
      CALL HCUM1('EPLL',dum1,wgtlep)
      CALL HCUM1('EPTT',dum1,wgtlep)
      dum1 = LOG10(yg1)
      dum2 = LOG10(yg2)
      CALL HCUM2('EGLL',dum1,dum2,wgtlep)
C--
      if(ntune.ne.3.and.fracq.gt.1.) then
      nfracq = ifix(fracq)
      dfracq  = fracq - nfracq
       if(ran(irr).lt.dfracq) nfracq=nfracq+1
       else
      nfracq = 1
      endif
      kfracq = 0
C--
263   continue
C--
      kfracq = kfracq + 1
      IF(CS.LT.1.) THEN
       SN   = SQRT(1.-CS**2)
       PHI  = PI2*RAN(IRR)
       XNEW          = ATAN2(SN*COS(PHI),CS)*DT/DXYZ(1)
       YNEW          = ATAN2(SN*SIN(PHI),CS)*DT/DXYZ(2)
         ELSE
       XNEW          = 0.
       YNEW          = 0.
      ENDIF
      NLEP=NLEP+1
      LEOR(NLEP)=3
      IF(I.GT.M) LEOR(NLEP)=-3
      IDLE(NLEP)=N
      EELE(NLEP)= SNGL(ENGLE)
ccc
      WGTLE(NLEP) = wgtlep
ccc
CPRTST            PRINT *,'!! PAIRLL,  NLEP,ENGLE,SN=',NLEP,ENGLE,SN
      XOLD          =XY(N,1,L1)-XY0(N,1,L1)
      YOLD          =XY(N,2,L1)-XY0(N,2,L1)
      XYLE(NLEP,1,1)=XGAM
      XYLE(NLEP,2,1)=XOLD + XNEW
      XYLE(NLEP,1,2)=YGAM
      XYLE(NLEP,2,2)=YOLD + YNEW
CNOKICK            XYLE(NLEP,2,1)= XNEW
CNOKICK            XYLE(NLEP,2,2)= YNEW
CTEST              XYLE(NLEP,2,1)= XOLD
CTEST              XYLE(NLEP,2,2)= XOLD
CTEST          XYLE(NLEP,1,1)= XY(N,1,L1)
CTEST          XYLE(NLEP,1,2)= XY(N,2,L1)
CDBG
ccc   PRINT *,' XNEW,YNEW:PAIRLL    =',XNEW,YNEW
ccc      PRINT *,' XNEW,YNEW:PAIRLL    =',XYLE(NLEP,2,1),XYLE(NLEP,2,2)
CDBG
ccc
      if(kfracq.lt.nfracq) go to 263
ccc
  260 CONTINUE
  300 CONTINUE
      RETURN
      END



