C   14/04/87 808291508  MEMBER NAME  SHIST3   *.FORT     M  FORTRAN77  
C******************** SHIST3 ******************************************
      SUBROUTINE SHIST3(KK,FACLM1,LPL0,NSTEP,NSBIN1,                   
     %          SBIN2,SBIN1,SBIN,SBINW)                                
      INCLUDE '@SHISCM'
      INCLUDE '@CHARCM'
      REAL*4 SCAL(8)                                                   
      REAL*4 SBIN2(NSBIN1,NSBIN1),SBIN(NSBIN1),SBIN1(NSBIN1,2),        
     %    SBINW(NSBIN1)                                                
      EXTERNAL SHISX1,SHISX2,SHISY1,SHISZ1,HETE                        
      CHARACTER*256 TTL                                                
C                                                                      
      IF(KK.EQ.2) GOTO 200                                             
      FAC=FACLM1/10000.                                                
      DO 110 K=1,NSBIN                                                 
      SBIN(K)=SBIN(K)*FAC                                              
      DO 110 K1=1,NSBIN                                                
  110 SBIN2(K1,K)=SBIN2(K1,K)*FAC                                      
      SBFAC=0.0                                                        
      DO 130 K=1,NSBIN                                                 
      SBIN1(K,1)=0.0                                                   
      SBIN1(K,2)=0.0                                                   
      DO 120 K1=1,NSBIN                                                
      SBIN1(K,1)=SBIN1(K,1)+SBIN2(K,K1)                                
  120 SBIN1(K,2)=SBIN1(K,2)+SBIN2(K1,K)                                
  130 SBFAC=SBFAC+SBIN1(K,1)                                           
      DO 140 K=1,NSBIN                                                 
      SBIN1(K,1)=SBIN1(K,1)/SBFAC                                      
  140 SBIN1(K,2)=SBIN1(K,2)/SBFAC                                      
      RETURN                                                           
C                                                                      
 200  continue
      CALL DOPT('RES,ALL ')   
C     CALL DOPT('OMIT',.FALSE.)                                        
C     CALL HOPTN('STAT',.TRUE.)
      WRITE(TTL,220) NSTEP                                             
  220 FORMAT('CENTER-OF-MASS ENERGY SPECTRUM  STEP',I2,';S/S0;',       
     %  'DLUM (1/CM**2/SEC/BIN)@')   
      CALL DOPT('ERROR',0) 
      CALL DOPT('LOWIN',.TRUE.) 
      LSSWCH=0                                                         
      IF(LPL0.EQ.0.OR.LPL0.GE.2) THEN                                  
          CALL DPSLCT(DEVNAM(1))
          CALL DUT1(SHISX2,SHISY1,DUMMY,NSBIN,TTL)
      ENDIF                                                            
      IF(LPL0.EQ.1.OR.LPL0.GE.2) THEN
          CALL DPSLCT(DEVNAM(2))  
          CALL DUT1(SHISX2,SHISY1,DUMMY,NSBIN,TTL)
        ENDIF                                                     
C---- 2-DIM PLOT
      WRITE(TTL,320) NSTEP                                             
  320 FORMAT('E1 VS. E2 SPECTRUM  STEP',I2,                            
     %   ' DLUM (1/CM**2/SEC/BIN);E1/E0;E2/E0@')                       
      CALL DOPT('LOWIN',.TRUE.)                                        
      CALL DOPT('LCOLS',133)                                           
      IF(NSBIN.GE.34) THEN                                             
          CALL DOPT('L2COL',2)                                         
        ELSE                                                           
          IF(NSBIN.GE.26) THEN                                         
              CALL DOPT('L2COL',3)                                     
            ELSE                                                       
              CALL DOPT('L2COL',4)                                     
            ENDIF                                                      
        ENDIF                                                          
C     CALL DOPT('L2CAUT',.TRUE.)                                       
C     CALL DOPT('L2SYM',36)                                            
      CALL DOPT('L2ZAUT',.TRUE.)                                       
      CALL DOPT('L2SYM',10)                                            
      LSSWCH=0                                                         
      IF(LPL0.EQ.0.OR.LPL0.GE.2) THEN                                  
          CALL DPSLCT(DEVNAM(1))                                       
          CALL DUT2(SHISX1,SHISX1,SHISZ1,DUMMY,NSBIN,NSBIN,TTL)        
        ENDIF                                                          
      IF(LPL0.EQ.1.OR.LPL0.GE.2) THEN                                  
          CALL DPSLCT(DEVNAM(2))                                       
          CALL DUT2(SHISX1,SHISX1,SHISZ1,DUMMY,NSBIN,NSBIN,TTL)        
        ENDIF                                                          
      IDEBUG=0                                                         
      IF(IDEBUG.EQ.0) GOTO 800                                         
      LSSWCH=1                                                         
      TTL(1:51)='E1 VS. E2 SPECTRUM REPRODUCED ASSUMING INDEP.DISTRI'  
      TTL(52:66)='BUTION@'                                             
      IF(LPL0.EQ.0.OR.LPL0.GE.2) THEN                                  
          CALL DPSLCT(DEVNAM(1))                                       
          CALL DUT2(SHISX1,SHISX1,SHISZ1,DUMMY,NSBIN,NSBIN,TTL)        
        ENDIF                                                          
      IF(LPL0.EQ.1.OR.LPL0.GE.2) THEN                                  
          CALL DPSLCT(DEVNAM(2))                                       
          CALL DUT2(SHISX1,SHISX1,SHISZ1,DUMMY,NSBIN,NSBIN,TTL)        
        ENDIF                                                          
C                                                                      
      CALL DOPT('YLOG',.TRUE.)                                         
      DO 400 L=1,2                                                     
      LSSWCH=L                                                         
      WRITE(TTL,380) L,L                                               
  380 FORMAT('SPECTRUM OF E',I1,' IN COLLISION EVENTS. SUM OF BINS=1.',
     %  ';E',I1,'/E0@')                                                
      CALL FITES(1,NSBIN,SBIN1(1,L),SBMIN,SBMAX,IRTN1,L)               
      IF(IRTN1.EQ.0) THEN                                              
          IF(LPL0.EQ.0.OR.LPL0.GE.2) THEN                              
              CALL DPSLCT(DEVNAM(1))                                   
              CALL DUT1(SHISX1,SHISY1,DUMMY,NSBIN,TTL,SCAL,HETE,1)     
            ENDIF                                                      
          IF(LPL0.EQ.1.OR.LPL0.GE.2) THEN                              
              CALL DPSLCT(DEVNAM(2))                                   
              CALL DUT1(SHISX1,SHISY1,DUMMY,NSBIN,TTL,SCAL,HETE,1)     
            ENDIF                                                      
        ELSE                                                           
          IF(LPL0.EQ.0.OR.LPL0.GE.2) THEN                              
              CALL DPSLCT(DEVNAM(1))                                   
              CALL DUT1(SHISX1,SHISY1,DUMMY,NSBIN,TTL)                 
            ENDIF                                                      
          IF(LPL0.EQ.1.OR.LPL0.GE.2) THEN                              
              CALL DPSLCT(DEVNAM(2))                                   
              CALL DUT1(SHISX1,SHISY1,DUMMY,NSBIN,TTL)                 
            ENDIF                                                      
        ENDIF                                                          
      CALL FITES(2,NSBIN,SBIN1(1,L),SBMIN,SBMAX,IRTN1,L)               
  400 CONTINUE                                                         
      CALL DOPT('YLOG',.FALSE.)                                        
C                                                                      
      DS=(SBMAX-SBMIN)/NSBIN                                           
      DE=DS                                                            
      DO 420 K=1,NSBIN                                                 
  420 SBINW(K)=0.0                                                     
      DO 490 J=1,NSBIN                                                 
      EMAX1=SBMIN+J*DE                                                 
      EMIN1=EMAX1-DE                                                   
      DO 480 I=1,NSBIN                                                 
      EMAX2=SBMIN+I*DE                                                 
      EMIN2=EMAX2-DE                                                   
      S11=EMIN1*EMIN2                                                  
      S22=EMAX1*EMAX2                                                  
      IF(S11.GT.SBMAX.OR.S22.LT.SBMIN) GOTO 480                        
      S12=EMIN1*EMAX2                                                  
      S21=EMAX1*EMIN2                                                  
      K1=INT((S11-SBMIN)/DS)+1                                         
      K2=INT((S22-SBMIN)/DS)+1                                         
      IF(K1.GT.K2.OR.K1.GT.NSBIN.OR.K2.LT.1) GOTO 480                  
      IF(K1.NE.K2) GOTO 440                                            
      SBINW(K1)=SBINW(K1)+SBIN1(I,1)*SBIN1(J,2)                        
      GOTO 480                                                         
  440 AREAS=(S21-S11)*(S12-S11)                                        
      AREA=0.0                                                         
      DO 460 K=MAX(1,K1),MIN(NSBIN,K2)                                 
      S=SBMIN+K*DS                                                     
      AREA0=AREA                                                       
      IF(S.GE.S22) THEN                                                
          AREA=1.0                                                     
        ELSE                                                           
          IF(S.GE.S21) THEN                                            
              IF(S.GE.S12) THEN                                        
                  AREA=0.5*(S22-S)**2/AREAS                            
                ELSE                                                   
                  AREA=(S-0.5*(S11+S21))*(S21-S11)/AREAS               
                ENDIF                                                  
            ELSE                                                       
              IF(S.GE.S12) THEN                                        
                  AREA=(S-0.5*(S11+S12))*(S12-S11)/AREAS               
                ELSE                                                   
                  AREA=0.5*(S-S11)**2/AREAS                            
                ENDIF                                                  
            ENDIF                                                      
        ENDIF                                                          
      SBINW(K)=SBINW(K)+SBIN1(I,1)*SBIN1(J,2)*(AREA-AREA0)             
  460 CONTINUE                                                         
  480 CONTINUE                                                         
  490 CONTINUE                                                         
      DO 500 K=1,NSBIN                                                 
  500 SBINW(K)=SBFAC*SBINW(K)                                          
      TTL='CENTER-OF-MASS ENERGY SPECTRUM REPRODUCED FROM E1 AND E2 '  
     %    //';S/S0@'                                                   
      LSSWCH=3                                                         
      IF(LPL0.EQ.0.OR.LPL0.GE.2) THEN                                  
          CALL DPSLCT(DEVNAM(1))                                       
          CALL DUT1(SHISX2,SHISY1,DUMMY,NSBIN,TTL)                     
        ENDIF                                                          
      IF(LPL0.EQ.1.OR.LPL0.GE.2) THEN                                  
          CALL DPSLCT(DEVNAM(2))                                       
          CALL DUT1(SHISX2,SHISY1,DUMMY,NSBIN,TTL)                     
        ENDIF                                                          
  800 RETURN                                                           
      END                                                              






