      FUNCTION CSPAIR(IRR,COSMIN)
CREAL8
      IMPLICIT  REAL*8 ( A-H,O-Z)
      REAL*4 RAN
CREAL8
C---
C Get cosine of e+(e-) of the pair
C         from the angular distribution of gamma-gamma-> e+e- process.
C  Its distribution is  1./(1-c**2), where c=cosine.
C---
C     A = (2.*RAN(IRR)-1.)*ALOG((1.+COSMIN)/(1.-COSMIN))
C     A = EXP(A)
      A      = (  ( 1.+COSMIN )/(1.-COSMIN)   )**( 2.*RAN(IRR)-1. )
      CSPAIR = (A-1.)/(A+1.)
C---
      RETURN
      END
