C   24/06/87 910031346  MEMBER NAME  DSTRIP   *.FORT        FORTRAN77   0000
      SUBROUTINE DSTRIP(KFLD,NP,NX,NY,BLEND,NT,RTZ,ZZ,                  0000
     %    MAXPH,IXYP,XYPH,IPHEL,                                        0000
     %    LCMPTN,MCPSQ,NCPSQ,ICPQN,ICPQK,ICPC,                          0000
     %    IZMM1,IZMIN,IZMAX,IPHIZ,IDPH)                                 0000
C PHOTON DISTRIBUTION IN RECTANGULAR CELLS.                             0000
C  THE CELLS ARE SPECIFIED BY (I,J)  (1<=I<=NX, 1<=J<=NY).              0000
C  (BLEND(1),BLEND(2)) IS THE COORDINATE OF THE CENTER OF THE           0000
C  CELL AT BOTTOM-LEFT CORNER (1,1).  THE CENTER OF THE (I,J)-TH        0000
C  CELL IS  X=BLEND(1)+(I-1), Y=BLEND(2)+(J-1).                         0000
C  1-DIM INDEX OF CELLS:  IXY=I+NX*(J-1)                                0000
C                                                                       0000
      REAL*4 BLEND(2)                                                   0000
      REAL*4 ZZ(NP,2),XYPH(MAXPH,4,2)                                   0000
      INTEGER IPHEL(MAXPH,2),IXYP(MAXPH,2)                              0000
      INTEGER ICPQN(MCPSQ,2),ICPQK(MCPSQ,2),ICPC(NX*NY,2),NCPSQ(2)      0000
      INTEGER IZMM1(2,2),IPHIZ(IZMIN:IZMAX+1,2),IDPH(MAXPH,2)           0000
C                                                                       0000
C--- CLEAR                                                              0000
      NCPSQ(1)=0                                                        0000
      NCPSQ(2)=0                                                        0000
C      CALL CLEAR(ICPQN,MCPSQ*2)                                         0000
C      CALL CLEAR(ICPQK,MCPSQ*2)                                         0000
C      CALL CLEAR(ICPC,NX*NY*2)                                          0000
      CALL UVZERO(MCPSQ*2,ICPQN)                                         0000
      CALL UVZERO(MCPSQ*2,ICPQK)                                         0000
      CALL UVZERO(NX*NY*2,ICPC)                                          0000
      S0=NT                                                             0000
      DO 500 L=1,2                                                      0000
      N1=IPHIZ(IZMM1(1,L),L)                                            0000
      N2=IPHIZ(IZMM1(2,L)+1,L)-1                                        0000
      IF(N2.LT.N1) GOTO 500                                             0000
      IF(KFLD.EQ.4) GOTO 260                                            0000
*VOPTION VEC(NOFVAL)                                                    0000
      DO 240 NN=N1,N2                                                   0000
      N=IDPH(NN,L)                                                      0000
      Z=ZZ(IPHEL(N,L),L)/RTZ+S0                                         0000
      X=XYPH(N,1,L)+XYPH(N,2,L)*Z                                       0000
      Y=XYPH(N,3,L)+XYPH(N,4,L)*Z                                       0000
      IX=NINT(X-BLEND(1))                                               0000
      IY=NINT(Y-BLEND(2))                                               0000
      IF(IX.LT.0.OR.IX.GE.NX.OR.IY.LT.0.OR.IY.GE.NY) THEN               0000
          IXYP(NN,L)=0                                                  0000
        ELSE                                                            0000
          IXYP(NN,L)=IX+1+NX*IY                                         0000
        ENDIF                                                           0000
  240 CONTINUE                                                          0000
      GOTO 300                                                          0000
*VOPTION VEC(NOFVAL)                                                    0000
  260 DO 280 NN=N1,N2                                                   0000
      N=IDPH(NN,L)                                                      0000
      Z=ZZ(IPHEL(N,L),L)/RTZ+S0                                         0000
      Y=XYPH(N,3,L)+XYPH(N,4,L)*Z                                       0000
      IY=NINT(Y)-BLEND(2)                                               0000
      IF(IY.LT.0.OR.IY.GE.NY) THEN                                      0000
          IXYP(NN,L)=0                                                  0000
        ELSE                                                            0000
          IXYP(NN,L)=1+IY                                               0000
        ENDIF                                                           0000
  280 CONTINUE                                                          0000
  300 CALL CMPTN1(IXYP(1,L),N1,N2,NCPSQ(L),                             0000
     %     MCPSQ,ICPQN(1,L),ICPQK(1,L),NX*NY,ICPC(1,L),LCMPTN)          0000
  500 CONTINUE                                                          0000
      RETURN                                                            0001
      END                                                               0001
