C   24/06/87 807201631  MEMBER NAME  EQMX     *.FORT        FORTRAN77   0000
      SUBROUTINE EQMX(NP,NX,NY,DX,DY,NTS,MT,MT1,NT,LOS1,MAXPH,          0000
     %    IRR,BLEND,AA,ZMIN,ZMAX,IXM,IYM,NPZ,NPZ0,NOUT1,                0000
     %    XY,XY0,FXY,IXY,XYTS,ZTS,ETS,ITTS,LTSRAD,                      0000
     %    XYPH,EPH,Q,PHI,DPHI,LOUT,LHIGH)                               0000
C  SOLVE EQUATION OF MOTION USING THE FIELD GIVEN BY SUBR.POISSN        0000
      INTEGER IXM(2,2),IYM(2,2),NPZ(2),NPZ0(2),NOUT1(2),IXY(NP,2)       0000
      INTEGER ITTS(NTS)                                                 0000
      REAL*4 BLEND(2),AA(2),ZMIN(2),ZMAX(2)                             0000
      REAL*4 XY(NP,2,2),XY0(NP,2,2),FXY(NP,2,2),                        0000
     %   XYTS(0:MT,NTS,2),ZTS(NTS),ETS(0:MT,NTS),                       0000
     %   XYPH(MAXPH,4,2),EPH(MAXPH,2)                                   0000
      REAL*4 DPHI(5*NX*NY)                                              0000
      REAL*8 Q(NX,NY,2),PHI(NX,NY,2)                                    0000
      REAL*8 E1                                                         0000
C                                                                       0000
      NT1=NT+1                                                          0000
      DO 500 L=1,2                                                      0000
      L2=3-L                                                            0000
      CALL PHIDER(NX,NY,PHI(1,1,L2),DPHI)                               0000
      CFX=AA(L2)/DX**2                                                  0000
      CFY=AA(L2)/DY**2                                                  0000
      DO 180 N=NPZ0(L),NPZ(L)                                           0000
      FXY(N,1,L)=0.0                                                    0000
  180 FXY(N,2,L)=0.0                                                    0000
C--- PARTICLES WITHIN GRID ---                                          0000
*VOPTION VEC(NOFVAL)                                                    0000
      DO 200 N=NPZ0(L),NPZ(L)                                           0000
      IXY1=IXY(N,L)-1                                                   0000
      IF(IXY1.LT.0) GOTO 200                                            0000
      PX=(XY0(N,1,L)-BLEND(1))-MOD(IXY1,NX)                             0000
      PY=(XY0(N,2,L)-BLEND(2))-(IXY1/NX)                                0000
      II=5*IXY1                                                         0000
      FXY(N,1,L)=CFX*(DPHI(II+1)+DPHI(II+3)*PX+DPHI(II+5)*PY)           0000
      FXY(N,2,L)=CFY*(DPHI(II+2)+DPHI(II+5)*PX+DPHI(II+4)*PY)           0000
C++++++++++++                                                           0000
      IF(LHIGH.NE.0) THEN                                               0000
          FXY1=FXY(N,1,L)                                               0000
          FXY2=FXY(N,2,L)                                               0000
          FXY(N,1,L)=FXY1+(FXY1*DPHI(II+3)+FXY2*DPHI(II+5))*CFX/12.0    0000
          FXY(N,2,L)=FXY2+(FXY2*DPHI(II+4)+FXY1*DPHI(II+5))*CFY/12.0    0000
        ENDIF                                                           0000
C++++++++++++                                                           0000
  200 CONTINUE                                                          0000
      IF(LOUT.EQ.0) GOTO 300                                            0000
      IF(NOUT1(L).EQ.0) GOTO 300                                        0000
C--- PARTICLES OUT OF GRID                                              0000
      DO 280 N=NPZ0(L),NPZ(L)                                           0000
      IF(IXY(N,L).GT.0) GOTO 280                                        0000
      XX1=XY0(N,1,L)-BLEND(1)+1.0                                       0000
      YY1=XY0(N,2,L)-BLEND(2)+1.0                                       0000
      DDX=0                                                             0000
      DDY=0                                                             0000
      DO 240 IY=IYM(1,L2),IYM(2,L2)                                     0000
      DO 240 IX=IXM(1,L2),IXM(2,L2)                                     0000
      DX1=XX1-IX                                                        0000
      DY1=YY1-IY                                                        0000
      DDD=(DX1*DX)**2+(DY1*DY)**2                                       0000
      DDX=DDX+Q(IX,IY,L2)*DX1/DDD                                       0000
      DDY=DDY+Q(IX,IY,L2)*DY1/DDD                                       0000
  240 CONTINUE                                                          0000
      FXY(N,1,L)=-DDX*AA(L2)                                            0000
      FXY(N,2,L)=-DDY*AA(L2)                                            0000
  280 CONTINUE                                                          0000
C                                                                       0000
C---- TEST PARTICLES                                                    0000
  300 IF(NTS.EQ.0.OR.L.EQ.2) GOTO 500                                   0000
      DO 400 I=1,NTS                                                    0000
      IF(NT.LT.ITTS(I)) GOTO 400                                        0000
      IF(ZTS(I).LT.ZMIN(1).OR.ZTS(I).GE.ZMAX(1)) GOTO 400               0000
      XX1=XYTS(NT1-MT1,I,1)-BLEND(1)                                    0000
      YY1=XYTS(NT1-MT1,I,2)-BLEND(2)                                    0000
      IX=NINT(XX1)                                                      0000
      IY=NINT(YY1)                                                      0000
      IF(IX.LT.0.OR.IX.GE.NX.OR.IY.LT.0.OR.IY.GE.NY) GOTO 330           0000
      PX=XX1-IX                                                         0000
      PY=YY1-IY                                                         0000
      II=5*(IX+NX*IY)                                                   0000
      DDX=CFX*(DPHI(II+1)+DPHI(II+3)*PX+DPHI(II+5)*PY)                  0000
      DDX=CFY*(DPHI(II+2)+DPHI(II+5)*PX+DPHI(II+4)*PY)                  0000
      GOTO 360                                                          0000
  330 DDX=0                                                             0000
      DDY=0                                                             0000
      DO 340 IY=IYM(1,L2),IYM(2,L2)                                     0000
      DO 340 IX=IXM(1,L2),IXM(2,L2)                                     0000
      DX1=XX1-IX                                                        0000
      DY1=YY1-IY                                                        0000
      DDD=(DX1*DX)**2+(DY1*DY)**2                                       0000
      DDX=DDX+Q(IX,IY,L2)*DX1/DDD                                       0001
      DDY=DDY+Q(IX,IY,L2)*DY1/DDD                                       0001
  340 CONTINUE                                                          0001
      DDX=-DDX*AA(L2)                                                   0001
      DDY=-DDY*AA(L2)                                                   0001
  360 DD=(DX*DDX)**2+(DY*DDY)**2                                        0001
      DDX=DDX/ETS(NT1-MT1,I)                                            0001
      DDY=DDY/ETS(NT1-MT1,I)                                            0001
      XYTS(NT1-MT1+1,I,1)=XYTS(NT1-MT1+1,I,1)+DDX                       0001
      XYTS(NT1-MT1+1,I,2)=XYTS(NT1-MT1+1,I,2)+DDY                       0001
      IF(LTSRAD.NE.0) THEN                                              0001
          E1=ETS(NT1-MT1+1,I)                                           0001
          CALL RADLOS(DD,E1,LOS1,IRR,0,0,MAXPH,IDMM,EPH,XYPH,NP,XY,XY0, 0001
     %                DMM,IDMM,IDMM,IDMM,IDMM,IDMM,IDMM)                0001
          ETS(NT1-MT1+1,I)=E1                                           0001
        ENDIF                                                           0001
  400 CONTINUE                                                          0001
  500 CONTINUE                                                          0001
      RETURN                                                            0001
      END                                                               0001
