C******************** FESPEC ****************************************   0000
      FUNCTION FESPEC(X)                                                0000
C  FESPEC(X)=                                                           0000
C    LOG(SUM X**N/(FACTORIAL(N)*GAMMA(N/3+1)) FROM N=0 TO INFINITY)     0000
      IMPLICIT REAL*8 (A-H,O-Z)                                         0000
C      REAL*4 FESPEC,X                                                   0000
      DIMENSION S(0:2)                                                  0000
      DATA G1/2.6789385347077476336556929409741168D0/,                  0000
     %     G2/1.3541179394264004169452880281540965D0/                   0000
C      G1=GAMMA(1/3), G2=GAMMA(2/3)                                     0000
      DATA PI/3.14159 26535 89793D0/                                    0000
      XD=X                                                              0000
      IF(X.GE.178.) GOTO 400                                            0000
      S(0)=1D0                                                          0000
      S(1)=1/G1                                                         0000
      S(2)=1/G2                                                         0000
      C1=1D0                                                            0000
      SUM=0D0                                                           0000
      N=0                                                               0000
  200 N=N+1                                                             0000
      SUM0=SUM                                                          0000
      C1=C1*(XD/N)                                                      0000
      M=MOD(N,3)                                                        0000
      S(M)=S(M)*3D0/N                                                   0000
      SUM=SUM+C1*S(M)                                                   0000
      IF(SUM.NE.SUM0) GOTO 200                                          0000
      IF(SUM.LE.1D-4) GOTO 300                                          0000
      FESPEC=LOG(1D0+SUM)                                               0000
      RETURN                                                            0000
  300 FESPEC=((((0.2D0*SUM+0.25D0)*SUM+0.3333333333333333D0)            0000
     %     *SUM+0.5D0)*SUM+1D0)*SUM                                     0000
      RETURN                                                            0000
  400 C1=SQRT(SQRT(3D0*XD**3))                                          0000
      C2=9D0/(8D0*PI*C1)                                                0000
      FESPEC=C1/0.75D0+0.5D0*LOG(C2)                                    0000
      RETURN                                                            0000
      END                                                               0000












