C   14/04/87 812161325  MEMBER NAME  FITEE    *.FORT     M  FORTRAN77   0000
C******************** FITEE ********************************************0000
      SUBROUTINE FITEE(KK,IDPL,NBIN,IRTN)                               0000
C  FIT LOW ENERGY TAIL OF FINAL ELECTRON DISTRIBUTION                   0000
      INCLUDE '@FITCOM'
      REAL*4 B(3,3)                                                     0000
      INTEGER HPNTR                                                     0000
      CHARACTER*4 IDPL                                                  0000
      DIMENSION IW(3),W(3)                                              0000
      EXTERNAL HETE                                                     0000
      CHARACTER*8 LKPL(8)/8*' '/                                        0000
      DATA KPL/4/                                                       0000
C                                                                       0000
      LKPL(KPL)='PLOTTED'                                               0000
      IF(KK.EQ.2) GOTO 400                                              0000
      IF(HPNTR(IDPL).EQ.0) STOP '??'                                    0000
      DO 140 I=1,NBIN                                                   0000
  140 IF(HY(I).NE.0) GOTO 150                                           0000
      GOTO 900                                                          0000
  150 I1=MAX(1,I-1)                                                     0000
      IF(NBIN-I1.LE.10) GOTO 900                                        0000
      DE=(HX(NBIN)-HX(1))/(NBIN-1)                                      0000
      E0=HX(1)                                                          0000
      FTOT=0                                                            0000
      DO 160 I=1,NBIN                                                   0000
  160 FTOT=FTOT+HY(I)                                                   0000
      DO 300 K0=1,8                                                     0000
      K=MOD(K0-1,4)+1                                                   0000
      I2=I1+NINT((NBIN-I1)*K/5.0)                                       0000
      E2EE(K0)=HX(I2)+DE                                                0000
      DO 120 J=1,3                                                      0000
      AEE(J,K0)=0                                                       0000
      DO 120 I=1,3                                                      0000
  120 B(I,J)=0                                                          0000
      IF(K0.GE.5) AEE(3,K0)=-2.0/3.0                                    0000
      DO 200 I=I1,I2                                                    0000
      F=HY(I)                                                           0000
      IF(F.LE.0) F=0.5                                                  0000
      E=E0+DE*(I-0.5)                                                   0000
      Y=1.0/E-1.0                                                       0000
      Y4=SQRT(SQRT(Y))                                                  0000
      YL=LOG(Y)                                                         0000
      WT=SQRT(F)                                                        0000
      F=LOG(F)                                                          0000
      IF(K0.GE.5) F=F-AEE(3,K0)*YL                                      0000
      B(1,1)=B(1,1)+WT                                                  0000
      B(1,2)=B(1,2)+WT*Y                                                0000
      B(2,2)=B(2,2)+WT*Y*Y                                              0000
      AEE(1,K0)=AEE(1,K0)+WT*F                                          0000
      AEE(2,K0)=AEE(2,K0)+WT*Y*F                                        0000
      IF(K0.GE.5) GOTO 200                                              0000
      B(1,3)=B(1,3)+WT*YL                                               0000
      B(2,3)=B(2,3)+WT*Y*YL                                             0000
      B(3,3)=B(3,3)+WT*YL*YL                                            0000
      AEE(3,K0)=AEE(3,K0)+WT*YL*F                                       0000
  200 CONTINUE                                                          0000
      NPAR=3                                                            0000
      IF(K0.GE.5) NPAR=2                                                0000
      DO 220 J=1,NPAR-1                                                 0000
      DO 220 I=J+1,NPAR                                                 0000
  220 B(I,J)=B(J,I)                                                     0000
      EPS=1E-6                                                          0000
      CALL RLINS3( B,3,NPAR,AEE(1,K0),IW,W,IRTN,EPS )                   0000
      IF(K0.EQ.KPL) THEN                                                0000
          DO 240 I=1,3                                                  0000
  240     AKPL(I)=AEE(I,KPL)                                            0000
        ENDIF                                                           0000
      AEE(1,K0)=AEE(1,K0)-LOG(DE*FTOT)                                  0000
  300 CONTINUE                                                          0000
      CALL HOPTN('FUNCTION',HETE,IDPL)                                  0000
      RETURN                                                            0000
  400 WRITE(6,410) (E2EE(K),(AEE(I,K),I=1,3),LKPL(K),K=1,8)             0000
  410 FORMAT(/,' ----- FIT OF FINAL ELECTRON ENERGY SPECTRUM -----',/,  0000
     % 10X,'DF/D(E/E0) = EXP(A+B*Y+C*LOG(Y))    Y=E0/E-1',/,            0000
     % 20X,'NORMALIZATION: INTEGRAL F*D(E/E0) = 1',/,                   0000
     % (15X,'FROM BINS E/E0<',0PF6.3,                                   0000
     %   '   A=',0PF10.5,'  B=',0PF10.5,'  C=',0PF10.5,3X,A8))          0000
      RETURN                                                            0000
  900 IRTN=1                                                            0000
      RETURN                                                            0000
      END                                                               0000
