C   14/04/87 812161326  MEMBER NAME  FXYGAU   *.FORT     M  FORTRAN77   0000
C******************** FXYGAU *******************************************0000
      FUNCTION FXYGAU(X,Y,SX,SY)                                        0000
C   ELECTROMAGNETIC FORCE OF GAUSSIAN BEAM                              0000
C   NOT USED IN TRACKING. FOR COMPARISON ONLY.                          0000
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 CMPZ,CMPFXY
      COMPLEX*16 FXYGAU,CWERF                                           0000
      DATA CC1/1.595769121D0/,CC2/0.7071067812D0/                       0000
C             CC1=SQRT(8/PI)                                            0000
      IF(ABS(SX-SY).GE.1D-5*SX) GOTO 200                                0000
      EX=0.5*(X**2+Y**2)/SX**2                                          0000
      IF(EX.LE.1D-5) GOTO 100                                           0000
      CMPZ=DCMPLX(X,-Y)    
      FAC=CC1*SX                                                        0000
      IF(EX.LE.40.) FAC=FAC*(1.-EXP(-EX))                               0000
      FXYGAU=FAC/CMPZ      
      RETURN                                                            0000
  100 FAC=CC1/(2.*SX)*(1.-0.5*EX)                                       0000
      FXYGAU=DCMPLX(FAC*X,FAC*Y)                                        0000
      RETURN                                                            0000
  200 XA=ABS(X)                                                         0000
      YA=ABS(Y)                                                         0000
      D1=1./SQRT(SX**2-SY**2)                                           0000
      D2=CC2*D1                                                         0000
      CMPZ=D2*DCMPLX(XA,YA)
      CMPFXY=CWERF(CMPZ) 
      EX=0.5*((X/SX)**2+(Y/SY)**2)                                      0000
      IF(EX.GE.40.) GOTO 300                                            0000
      R=SX/SY                                                           0000
      CMPZ=DCMPLX(D2*XA/R,D2*YA*R)               
      CMPFXY=CMPFXY-EXP(-EX)*CWERF(CMPZ)         
  300 CMPFXY=D1*(SX+SY)*CMPFXY                   
      IF(X.LT.0.0) CMPFXY=DCONJG(CMPFXY)         
      FXYGAU=DCMPLX(DIMAG(CMPFXY),DREAL(CMPFXY)) 
      IF(Y.LT.0.0) FXYGAU=DCONJG(FXYGAU)                                0000
      RETURN                                                            0000
      END                                                               0000
