C   28/08/87 709011917  MEMBER NAME  PHIDER   *.FORT        FORTRAN77   0000
      SUBROUTINE PHIDER(NX,NY,PHI,DPHI)                                 0000
C  DERIVATIVES OF PHI.                                                  0000
C   PHI(I+X,J+Y)=PHI(I,J)+DPHI(1,I,J)*X+DPHI(2,I,J)*Y                   0000
C      +0.5*DPHI(3,I,J)*X**2+0.5*DPHI(4,I,J)*Y**2+DPHI(5,I,J,)*X*Y      0000
C                                                                       0000
      REAL*8 PHI(NX,NY)                                                 0000
      REAL*4 DPHI(5,NX,NY)                                              0000
C                                                                       0000
C--- INNER CELLS                                                        0000
      DO 200 J=2,NY-1                                                   0000
      DO 200 I=2,NX-1                                                   0000
      DPHI(1,I,J)=0.5D0*(PHI(I+1,J)-PHI(I-1,J))                         0000
      DPHI(2,I,J)=0.5D0*(PHI(I,J+1)-PHI(I,J-1))                         0000
      DPHI(3,I,J)=PHI(I+1,J)-2*PHI(I,J)+PHI(I-1,J)                      0000
      DPHI(4,I,J)=PHI(I,J+1)-2*PHI(I,J)+PHI(I,J-1)                      0000
      DPHI(5,I,J)=0.25D0                                                0000
     %       *(PHI(I+1,J+1)-PHI(I+1,J-1)-PHI(I-1,J+1)+PHI(I-1,J-1))     0000
  200 CONTINUE                                                          0000
C--- OUTERMOST CELLS                                                    0000
      DO 220 J=2,NY-1                                                   0000
      DPHI(1,1,J)=DPHI(1,2,J)-DPHI(3,2,J)                               0000
      DPHI(2,1,J)=DPHI(2,2,J)-DPHI(5,2,J)                               0000
      DPHI(3,1,J)=DPHI(3,2,J)                                           0000
      DPHI(4,1,J)=DPHI(4,2,J)                                           0000
      DPHI(5,1,J)=DPHI(5,2,J)                                           0000
      DPHI(1,NX,J)=DPHI(1,NX-1,J)+DPHI(3,NX-1,J)                        0000
      DPHI(2,NX,J)=DPHI(2,NX-1,J)+DPHI(5,NX-1,J)                        0000
      DPHI(3,NX,J)=DPHI(3,NX-1,J)                                       0000
      DPHI(4,NX,J)=DPHI(4,NX-1,J)                                       0000
      DPHI(5,NX,J)=DPHI(5,NX-1,J)                                       0000
  220 CONTINUE                                                          0000
      DO 240 I=1,NX                                                     0000
      DPHI(1,I,1)=DPHI(1,I,2)-DPHI(5,I,2)                               0000
      DPHI(2,I,1)=DPHI(2,I,2)-DPHI(4,I,2)                               0000
      DPHI(3,I,1)=DPHI(3,I,2)                                           0000
      DPHI(4,I,1)=DPHI(4,I,2)                                           0000
      DPHI(5,I,1)=DPHI(5,I,2)                                           0000
      DPHI(1,I,NY)=DPHI(1,I,NY-1)+DPHI(5,I,NY-1)                        0000
      DPHI(2,I,NY)=DPHI(2,I,NY-1)+DPHI(4,I,NY-1)                        0000
      DPHI(3,I,NY)=DPHI(3,I,NY-1)                                       0000
      DPHI(4,I,NY)=DPHI(4,I,NY-1)                                       0000
      DPHI(5,I,NY)=DPHI(5,I,NY-1)                                       0000
  240 CONTINUE                                                          0000
      RETURN                                                            0000
      END                                                               0000
