C   12/11/87 909281421  MEMBER NAME  PLENHZ   *.FORT        FORTRAN77   0000
      SUBROUTINE PLENHZ(LENHZ,ENH,ENHZ,NPIZ,IZMIN,IZMAX,DT1,NP)         0000
      INCLUDE '@TDCOM'
      DIMENSION ENHZ(IZMIN:IZMAX+1,2),NPIZ(IZMIN:IZMAX+1,2)             0000
      CHARACTER*1 LPLBM                                                 0000
      DATA PI/3.14159265E0/                                             0000
C                                                                       0000
      IPLBM=MIN(2,LENHZ/10)                                             0000
      LENHZ2=MAX(0,MIN(3,MOD(LENHZ,10)))                                0000
C      CORRECTION DUE TO RANDOM POPULATION OF Z-SUBSLICES               0000
      FAC=NP*DT1/SQRT(2.0*PI)                                           0000
      DO 140 L=1,2                                                      0000
      DO 120 IZ=IZMIN,IZMAX                                             0000
      NP1=NPIZ(IZ+1,L)-NPIZ(IZ,L)                                       0000
      IF(NP1.LE.0) GOTO 120                                             0000
      Z1=(IZ+0.5)*DT1                                                   0000
      ENHZ(IZ,L)=ENHZ(IZ,L)*FAC*EXP(-Z1**2/2.0)/NP1                     0000
  120 CONTINUE                                                          0000
  140 CONTINUE                                                          0000
C---- PRINT                                                             0000
      IF(LENHZ2.NE.1.AND.LENHZ2.NE.3) GOTO 300                          0000
      DO 220 L=1,2                                                      0000
      WRITE(6,200) L,(IZ,(IZ+0.5)*DT1,ENHZ(IZ,L),IZ=IZMIN,IZMAX)        0000
  200 FORMAT(/,' **** ENHANCEMENT FACTOR: CONTRIBUTION OF EACH ',       0000
     %  'Z-SUBSLICE OF BEAM#',I1,'. (Z IN UNITS OF SIGZ1)  ***',/,      0000
     %  2X,5('    IZ    Z     DELTA H '),/,(2X,5(I6,F8.4,F10.6)))       0000
  220 CONTINUE                                                          0000
C----PLOT                                                               0000
  300 IF(LENHZ2.NE.2.AND.LENHZ2.NE.3) RETURN                            0000
      LPLBM=' '                                                         0000
      IF(IPLBM.EQ.1) LPLBM='1'                                          0000
      IF(IPLBM.EQ.2) LPLBM='2'                                          0000
      WRITE(6,310) LPLBM,IFLTD                                          0000
  310 FORMAT(/,' (SUBR.PLENHZ) PLOT DH/DZ',A1,' ON FT0',I1,'F001.')     0000
C     ZMIN=(IZMIN+0.5)*DT1                                              0000
C     ZMAX=(IZMAX+0.5)*DT1                                              0000
      ZMIN=-2.5                                                         0000
      ZMAX=2.5                                                          0000
      FMAX=0                                                            0000
      IF(LPLBM.EQ.' ') THEN                                             0000
          DO 320 IZ=IZMIN,IZMAX                                         0000
  320     FMAX=MAX(FMAX,ENHZ(IZ,1)+ENHZ(IZ,2))                          0000
          FMAX=FMAX/2.0                                                 0000
        ELSE                                                            0000
          DO 340 IZ=IZMIN,IZMAX                                         0000
  340     FMAX=MAX(FMAX,ENHZ(IZ,IPLBM))                                 0000
        ENDIF                                                           0000
      IF(FMAX.LE.0) RETURN                                              0000
      FMAX=ROUND(FMAX/DT1,2)                                            0000
      CALL TDHEAD                                                       0000
      WRITE(IFLTD,400) ENH,LPLBM,LPLBM,ZMIN,ZMAX,FMAX                   0000
  400 FORMAT(                                                           0000
     %   ' TITLE TOP ',1H','  ENHANCE=',F6.3,1H',/,                     0000
     %   ' TITLE BOTTOM ',1H','Z',A1,'/SIGZ',1H',/,                     0000
     %   ' TITLE LEFT ',1H','DH/DZ',A1,1H',/,                           0000
     %   ' SET LIMIT X FROM ',F6.3,' TO ',F6.3,/,                       0000
     %   ' SET LIMIT Y FROM 0.0 TO ',F10.4)                             0000
      IF(LPLBM.EQ.' ') THEN                                             0000
          WRITE(IFLTD,440) ((IZ+0.5)*DT1,(ENHZ(IZ,1)+ENHZ(IZ,2))        0000
     %         /(2*DT1),IZ=IZMIN,IZMAX)                                 0000
        ELSE                                                            0000
          WRITE(IFLTD,440) ((IZ+0.5)*DT1,ENHZ(IZ,IPLBM)/DT1,            0000
     %         IZ=IZMIN,IZMAX)                                          0000
        ENDIF                                                           0000
  440 FORMAT(3(F11.5,F12.8,';'))                                        0000
      WRITE(IFLTD,460)                                                  0000
  460 FORMAT(' JOIN 1')                                                 0000
      RETURN                                                            0000
      END                                                               0000
