C   14/04/87 807191409  MEMBER NAME  PRFLD    *.FORT     M  FORTRAN77   0000
C******************** PRFLD ********************************************0000
      SUBROUTINE PRFLD(KFLD,NT,L,NN,AA,NXA,NYA,Q,PHI,EX,EY)             0000
C  PRINT THE FIELD. FOR DEBUG.                                          0000
      INCLUDE '@BBCOM'
      REAL*8 PHI(NXA,NYA,2),Q(NXA,NYA,2)                                0000
      REAL*4 EX(0:NXA,2),EY(NXA,0:NYA,2)                                0000
      DIMENSION FF(20),NNX(2),NNY(2)                                    0000
      REAL*4 AA(2)                                                      0000
      REAL*8 XD,YD,SIG1D,SIG2D                                          0000
      COMPLEX*16 FXYGAU                                                 0000
      COMPLEX*8  FXYG                                                   0000
      REAL*4 FXYGRI(2)                                                  0000
      EQUIVALENCE (FXYG,FXYGRI)                                         0000
      CHARACTER*10 LXY(2)/'HORIZONTAL','VERTICAL'/                      0000
      DATA ELR/2.817938D-15/                                            0000
C                                                                       0000
      X00=0.5*(NX+1)                                                    0000
      Y00=0.5*(NY+1)                                                    0000
      QMAX=1D-40                                                        0000
      DO 120 J=1,NY                                                     0000
      DO 120 I=1,NX                                                     0000
  120 QMAX=MAX(QMAX,SNGL(Q(I,J,L)))                                     0000
      FAC=10.0**(104-INT(LOG10(QMAX*1.0001)+100))                       0000
      WRITE(6,140) 1/FAC,L,NT,NN                                        0000
  140 FORMAT(1H1,/,'  *** CHARGE DISTRIBUTION (IN UNITS OF ',1PD7.1,    0000
     %  ') IN BUNCH#',I1,' AT S=0,T=',I4,', # OF PARTICLES=',I4,/,      0000
     %  20X,'(X,Y) IN UNITS OF (DX,DY)')                                0000
      II=1                                                              0000
  160 II1=MIN(II+19,NX)                                                 0000
      WRITE(6,180) (I-X00,I=II,II1)                                     0000
  180 FORMAT(/,'   Y    X=',20F6.1)                                     0000
      DO 220 J=NY,1,-1                                                  0000
      WRITE(6,200) J-Y00,(NINT(Q(I,J,L)*FAC),I=II,II1)                  0000
  200 FORMAT(1X,F6.1,3X,20I6)                                           0000
  220 CONTINUE                                                          0000
      II=II1+1                                                          0000
      IF(II.LE.NX) GOTO 160                                             0000
C                                                                       0000
      IF(KFLD.EQ.3) GOTO 600                                            0000
      NNX(1)=1                                                          0000
      NNX(2)=0                                                          0000
      NNY(1)=0                                                          0000
      NNY(2)=1                                                          0000
      FMAX=1D-40                                                        0000
      DO 320 IXY=1,2                                                    0000
      AA1=AA(L)/DXYZ(IXY)**2                                            0000
      DO 320 J=1,NY-NNY(IXY)                                            0000
      DO 320 I=1,NX-NNX(IXY)                                            0000
  320 FMAX=MAX(FMAX,ABS(AA1*SNGL(PHI(I+NNX(IXY),J+NNY(IXY),L)           0000
     %                      -PHI(I,J,L))))                              0000
      FAC=10.0**(104-INT(LOG10(FMAX*1.0001)+100))                       0000
      S=0.0                                                             0000
      FAC1=2.*AN(L)*ELR/GAM(3-L)*DT**2/(SIG(3,L)*(SIG(1,L)+SIG(2,L)))   0000
      FAC1=FAC1*EXP(-0.5*((S*DXYZ(3)+NT*DT)/SIG(3,L))**2)               0000
      DO 500 IXY=1,2                                                    0000
      AA1=AA(L)/DXYZ(IXY)**2                                            0000
      WRITE(6,340) LXY(IXY),1/FAC,L,NT,NN                               0000
  340 FORMAT(1H1,/,'  *** ',A10,' FIELD (IN UNITS OF ',1PD7.1,          0000
     %  ') BY BUNCH#',I1,' AT S=0, T=',I4,', # OF PARTICLES=',I4,/,     0000
     %  20X,'(X,Y) IN UNITS OF (DX,DY).  "G"S ARE THOSE OF GAUSSIAN',   0000
     %  ' BEAM WITH INITIAL SHAPE.')                                    0000
      II=1                                                              0000
  360 II1=MIN(II+19,NX-NNX(IXY))                                        0000
      HALFX=0.0                                                         0000
      IF(IXY.EQ.1) HALFX=0.5                                            0000
      WRITE(6,380) (I-X00+HALFX,I=II,II1)                               0000
  380 FORMAT(/,'  Y    X=',20F6.1)                                      0000
      HALFY=0.5-HALFX                                                   0000
      DO 480 J=NY-NNY(IXY),1,-1                                         0000
      Y=J-Y00+HALFY                                                     0000
      WRITE(6,400) Y,(NINT((PHI(I+NNX(IXY),J+NNY(IXY),L)                0000
     %                 -PHI(I,J,L))*AA1*FAC),I=II,II1)                  0000
  400 FORMAT(1X,F5.1,3X,20I6)                                           0000
      DO 420 I=1,II1-II+1                                               0000
      X=II+I-1-X00+HALFX                                                0000
      XD=X*DXYZ(1)                                                      0000
      YD=Y*DXYZ(2)                                                      0000
      SIG1D=SIG(1,L)                                                    0000
      SIG2D=SIG(2,L)                                                    0000
      FXYG=-FXYGAU(XD,YD,SIG1D,SIG2D)                                   0000
      FF(I)=FAC1/DXYZ(IXY)*FXYGRI(IXY)                                  0000
  420 CONTINUE                                                          0000
      WRITE(6,440) (NINT(FF(I)*FAC),I=1,II1-II+1)                       0000
  440 FORMAT(6X,'G',3X,20I6)                                            0000
  480 CONTINUE                                                          0000
      II=II1+1                                                          0000
      IF(II.LE.NX-NNX(IXY)) GOTO 360                                    0000
  500 CONTINUE                                                          0000
      RETURN                                                            0000
C                                                                       0000
  600 FMAX=1D-40                                                        0000
      AA1=AA(L)/DXYZ(1)**2                                              0000
      DO 620 I=0,NX                                                     0000
  620 FMAX=MAX(FMAX,ABS(AA1*EX(I,L)))                                   0000
      FAC=10.0**(104-INT(LOG10(FMAX*1.0001)+100))                       0000
      S=0.0                                                             0000
      FAC1=2.*AN(L)*ELR/GAM(3-L)*DT**2/(SIG(3,L)*(SIG(1,L)+SIG(2,L)))   0000
      FAC1=FAC1*EXP(-0.5*((S*DXYZ(3)+NT*DT)/SIG(3,L))**2)               0000
      WRITE(6,640) LXY(1),1/FAC,L,NT,NN                                 0000
  640 FORMAT(//,'  *** ',A10,' FIELD (IN UNITS OF ',1PD7.1,             0000
     %  ') BY BUNCH#',I1,' AT S=0, T=',I4,', # OF PARTICLES=',I4,/,     0000
     %  20X,'(X,Y) IN UNITS OF (DX,DY).  "G"S ARE THOSE OF GAUSSIAN',   0000
     %  ' BEAM WITH INITIAL SHAPE ON Y AXIS.')                          0000
      II=0                                                              0000
  660 II1=MIN(II+19,NX)                                                 0000
      WRITE(6,680) (I-X00+0.5,I=II,II1)                                 0000
  680 FORMAT(/,'  Y    X=',20F6.1)                                      0000
      Y=0                                                               0000
      WRITE(6,700) Y,(NINT(EX(I,L)*AA1*FAC),I=II,II1)                   0000
  700 FORMAT(1X,F5.1,3X,20I6)                                           0000
      DO 720 I=1,II1-II+1                                               0000
      X=II+I-1-X00+0.5                                                  0000
      XD=X*DXYZ(1)                                                      0000
      YD=0D0                                                            0000
      SIG1D=SIG(1,L)                                                    0000
      SIG2D=SIG(2,L)                                                    0000
      FXYG=-FXYGAU(XD,YD,SIG1D,SIG2D)                                   0000
      FF(I)=FAC1/DXYZ(1)*FXYGRI(1)                                      0000
  720 CONTINUE                                                          0000
      WRITE(6,740) (NINT(FF(I)*FAC),I=1,II1-II+1)                       0000
  740 FORMAT(6X,'G',3X,20I6)                                            0000
      II=II1+1                                                          0000
      IF(II.LE.NX) GOTO 660                                             0000
C                                                                       0000
      FMAX=1D-40                                                        0000
      AA1=AA(L)/DXYZ(2)**2                                              0000
      DO 820 J=0,NY                                                     0000
      DO 820 I=1,NX                                                     0000
  820 FMAX=MAX(FMAX,ABS(AA1*EY(I,J,L)))                                 0000
      FAC=10.0**(104-INT(LOG10(FMAX*1.0001)+100))                       0000
      S=0.0                                                             0000
      FAC1=2.*AN(L)*ELR/GAM(3-L)*DT**2/(SIG(3,L)*(SIG(1,L)+SIG(2,L)))   0000
      FAC1=FAC1*EXP(-0.5*((S*DXYZ(3)+NT*DT)/SIG(3,L))**2)               0000
      WRITE(6,840) LXY(2),1/FAC,L,NT,NN                                 0000
  840 FORMAT(1H1,/,'  *** ',A10,' FIELD (IN UNITS OF ',1PD7.1,          0000
     %  ') BY BUNCH#',I1,' AT S=0, T=',I4,', # OF PARTICLES=',I4,/,     0000
     %  20X,'(X,Y) IN UNITS OF (DX,DY).  "G"S ARE THOSE OF GAUSSIAN',   0000
     %  ' BEAM WITH INITIAL SHAPE.')                                    0000
      II=1                                                              0000
  860 II1=MIN(II+19,NX)                                                 0000
      WRITE(6,880) (I-X00,I=II,II1)                                     0000
  880 FORMAT(/,'  Y    X=',20F6.1)                                      0000
      DO 980 J=NY,0,-1                                                  0000
      Y=J-Y00+0.5                                                       0000
      WRITE(6,900) Y,(NINT(EY(I,J,L)*AA1*FAC),I=II,II1)                 0000
  900 FORMAT(1X,F5.1,3X,20I6)                                           0000
      DO 920 I=1,II1-II+1                                               0000
      X=II+I-1-X00                                                      0000
      XD=X*DXYZ(1)                                                      0000
      YD=Y*DXYZ(2)                                                      0000
      SIG1D=SIG(1,L)                                                    0000
      SIG2D=SIG(2,L)                                                    0000
      FXYG=-FXYGAU(XD,YD,SIG1D,SIG2D)                                   0000
      FF(I)=FAC1/DXYZ(2)*FXYGRI(2)                                      0000
  920 CONTINUE                                                          0000
      WRITE(6,940) (NINT(FF(I)*FAC),I=1,II1-II+1)                       0000
  940 FORMAT(6X,'G',3X,20I6)                                            0000
  980 CONTINUE                                                          0000
      II=II1+1                                                          0000
      IF(II.LE.NX) GOTO 860                                             0000
      RETURN                                                            0000
      END                                                               0000
