C   14/04/87 706242325  MEMBER NAME  RPTAIL   *.FORT     M  FORTRAN77   0000
C******************** RPTAIL ****************************************** 0000
      SUBROUTINE RPTAIL(KK,IDPL,KB,NP,MP,AN,RP,DTH,NB)                  0000
C  FITTING THE TAIL OF RP DISTRIBUTION.                                 0000
      REAL*4 AN(2)                                                      0000
      REAL*4 RP(MP,2)                                                   0000
      CHARACTER*4 IDPL                                                  0000
      CHARACTER*8 LBEAM(3)/'BEAM#1  ','BEAM#2  ','BEAM#1+2'/            0000
      REAL*4 THLVL(3)/0.3,0.1,0.03/                                     0000
      REAL*4 CN(3),CTH(3),TH(3),CFRAC(3)                                0000
      INTEGER NBTH(3),NTH(3)                                            0000
      INTEGER HPNTR                                                     0000
C                                                                       0000
      L1=KB                                                             0000
      L2=KB                                                             0000
      IF(KB.EQ.3) L1=1                                                  0000
      IF(KB.EQ.3) L2=2                                                  0000
      IF(KK.EQ.2) GOTO 1000                                             0000
      IF(HPNTR(IDPL).EQ.0) RETURN                                       0000
      FMAX=0                                                            0000
      DO 200 I=1,NB                                                     0000
  200 FMAX=MAX(FMAX,HY(I))                                              0000
      DO 400 J=1,3                                                      0000
      FCUT=THLVL(J)*FMAX                                                0000
      NBTH(J)=0                                                         0000
      DO 220 I=NB,1,-1                                                  0000
  220 IF(HY(I).GE.FCUT) GOTO 240                                        0000
  240 N=NB-I                                                            0000
      I0=I+1                                                            0000
      IF(N.LE.3) GOTO 400                                               0000
      NBTH(J)=N                                                         0000
      TH(J)=HX(I0)-0.5*DTH                                              0000
      TCUT=TH(J)/1E6                                                    0000
      NTH(J)=0                                                          0000
      TAV=0                                                             0000
                                                                        0000
      DO 260 L=L1,L2                                                    0000
      DO 260 N=1,NP                                                     0000
      IF(RP(N,L).LT.TCUT) GOTO 260                                      0000
      TAV=TAV+RP(N,L)                                                   0000
      NTH(J)=NTH(J)+1                                                   0000
  260 CONTINUE                                                          0000
      TAV=TAV/NTH(J)                                                    0000
      CFRAC(J)=FLOAT(NTH(J))/FLOAT(NP)                                  0000
      IF(KB.EQ.3) CFRAC(J)=CFRAC(J)/2                                   0000
      CTH(J)=(TAV-TCUT)*1E6                                             0000
      CN(J)=AN(L1)/NP*NTH(J)/CTH(J)*EXP(TH(J)/CTH(J))                   0000
      IF(KB.EQ.3) CN(J)=CN(J)/2                                         0000
  400 CONTINUE                                                          0000
      RETURN                                                            0000
 1000 WRITE(6,1020) LBEAM(KB)                                           0000
 1020 FORMAT(/,' *** FIT OF THE LARGE ANGLE TAIL FROM ',A8,' ***',/,    0000
     % 5X,'DN/DTH=C*EXP(-TH/TH1)   C=PARTICLES/MICRAD/BEAM ',           0000
     % ' TH1=MICRAD',/)                                                 0000
      DO 1140 J=1,3                                                     0000
      IF(NBTH(J).EQ.0) GOTO 1140                                        0000
      WRITE(6,1120) NTH(J),CFRAC(J)*100.,TH(J),CN(J),CTH(J)             0000
 1120 FORMAT(' FROM',I5,' PARTICLES (',F6.3,'%) ABOVE',F9.3,'(MICRAD)', 0000
     %  T50,'C=',1PE10.3,'  TH1=',0PF9.3)                               0000
 1140 CONTINUE                                                          0000
      RETURN                                                            0000
      END                                                               0000
