C   14/04/87 910032131  MEMBER NAME  TSTRAJ   *.FORT     M  FORTRAN77   0000
C******************** TSTRAJ *******************************************0000
      SUBROUTINE TSTRAJ(MT,MTS,NTS1,LTS,XTS0,YTS0,XPTS0,YPTS0,ZTS0,ETS0,0000
     %                  XYTS,ETS,ITTS)                                  0000
      INCLUDE '@BBCOM'
      REAL*4 XTS0(MTS),YTS0(MTS),XPTS0(MTS),YPTS0(MTS),ZTS0(MTS),       0000
     %       ETS0(MTS),XYTS(0:MT,NTS1,2),ETS(0:MT,NTS1)                 0000
      INTEGER ITTS(MTS)                                                 0000
      REAL*4 DXYZ0(3)                                                   0000
C                                                                       0000
      DO 90 I=1,3                                                       0000
   90 DXYZ0(I)=DXYZ(I)/SIG(I,1)                                         0000
      DT0=DT/SIG(3,1)                                                   0000
      WRITE(6,100)                                                      0000
  100 FORMAT(//' *** TRAJECTORY OF THE TEST PARTICLES IN THE ',         0000
     % 'BUNCH #1 ***',//,                                               0000
     % 5X,'INITIAL CONDITIONS (SPECIFIED AT S=0)',/,                    0000
     % '  #      X(SIGX)     X''(SIGX/SIGZ) ',                          0000
     %  '    Y(SIGY)     Y''(SIGY/SIGZ)     Z(SIGZ)    ',               0000
     %  '     E/ENGY(1)     START TIME/SIGZ')                           0000
      WRITE(6,110) (I,XTS0(I),XPTS0(I),YTS0(I),YPTS0(I),ZTS0(I),        0000
     %     ETS0(I),ITTS(I)*DT0,I=1,NTS)                                 0000
  110 FORMAT(1X,I2,2X,7F15.6)                                           0000
      WRITE(6,120)                                                      0000
  120 FORMAT('  #       X(MIC)      X''(MILLIRAD) ',                    0000
     %  '     Y(MIC)      Y''(MILLIRAD)      Z(MM)     ')               0000
      WRITE(6,130) (I,XTS0(I)*SIG(1,1),XPTS0(I)*SIG(1,1)/SIG(3,1),      0000
     %  YTS0(I)*SIG(2,1),YPTS0(I)*SIG(2,1)/SIG(3,1),                    0000
     %  ZTS0(I)*SIG(3,1),I=1,NTS)                                       0000
  130 FORMAT((1X,I2,2X,2(6PF15.6,3PF15.8),3PF15.8))                     0000
      WRITE(6,140)                                                      0000
  140 FORMAT(5X,'FINAL',/,'  #       X(MIC)      X''(MILLIRAD) ',       0000
     %  '     Y(MIC)      Y''(MILLIRAD)      Z(MM)     ',               0000
     %  '      E/E0     ')                                              0000
      WRITE(6,150) (I,(XYTS(MT2-MT1+1,I,IXY)*DXYZ(IXY),                 0000
     %  (XYTS(MT2-MT1+1,I,IXY)-XYTS(MT2-MT1,I,IXY))*DXYZ(IXY)/DT,       0000
     %  IXY=1,2),ETS(MT2-MT1+1,I),I=1,NTS)                              0000
  150 FORMAT((1X,I2,2X,2(6PF15.6,3PF15.8),15X,0PF15.8))                 0000
      IF(LTS.EQ.2) GOTO 300                                             0000
      IA=1                                                              0000
  160 IB=MIN(NTS,IA+2)                                                  0000
      WRITE(6,180) (I,I=IA,IB)                                          0000
  180 FORMAT('   T/SIGZ',3('  #',I2,'  X       X''          Y    ',     0000
     %  '   Y''    '))                                                  0000
      DO 220 N=1,MT2-MT1+1                                              0000
      WRITE(6,200) (N+MT1-1)*DT0,((XYTS(N,I,IXY)*DXYZ0(IXY),            0000
     % (XYTS(N,I,IXY)-XYTS(N-1,I,IXY))*DXYZ0(IXY)/DT0,                  0000
     % IXY=1,2),I=IA,IB)                                                0000
  200 FORMAT(1X,F8.5,3(3X,F9.5,F9.5,2X,F9.5,F9.5))                      0000
  220 CONTINUE                                                          0000
      IA=IA+3                                                           0000
      IF(IA.LE.NTS) GOTO 160                                            0000
  300 CALL PRTIME(20,11,'SUBR.TSTRAJ')                                  0000
      RETURN                                                            0000
      END                                                               0000
